Var DOWNLOAD_RESULT

!macro Download URL FILE

	${If} $PROXY_TYPE == "auto"
		inetc::get /SILENT /RESUME "Error Connecting To The Internet.$\rPlease Check Your Connection and Settings." "${URL}" "${FILE}" /END
	${ElseIf} $PROXY_TYPE == "proxy"
		${If} $PROXY_USER == ""
			inetc::get /SILENT /RESUME "Error Connecting To The Internet.$\rPlease Check Your Connection and Settings." /PROXY $PROXY_ADDRESS "${URL}" "${FILE}" /END
		${Else}
			inetc::get /SILENT /RESUME "Error Connecting To The Internet.$\rPlease Check Your Connection and Settings." /PROXY $PROXY_ADDRESS /USER $PROXY_USER /PASSWORD $PROXY_PASSWORD "${URL}" "${FILE}" /END
		${EndIf}
	${EndIf}

	Pop $DOWNLOAD_RESULT

!macroend

!define Download `!insertmacro Download`

!macro UpdateBanner TEXT

	Banner::getWindow /NOUNLOAD
	Pop $R0
	GetDlgItem $R0 $R0 1030
	SendMessage $R0 ${WM_SETTEXT} 0 "STR:${TEXT}"

!macroend

!define UpdateBanner `!insertmacro UpdateBanner`

!macro _ProcessRunning _a _b _t _f
  FindProcDLL::FindProc "${_b}"
  !insertmacro _== $R0 1 `${_t}` `${_f}`
!macroend

!define ProcessRunning `"" ProcessRunning`

!macro CheckPasswordStrength PASSWORD NAME

	StrLen $0 ${PASSWORD}
	${If} $0 < 7
		MessageBox MB_OK "${NAME} must contain at least 7 digits and letters"
		Abort
	${EndIf}

	${StrFilter} ${PASSWORD} 12 "" "" $0
	${If} ${PASSWORD} != $0
		MessageBox MB_OK "${NAME} must contain only digits and letters"
		Abort
	${EndIf}

	${StrFilter} ${PASSWORD} 1 "" "" $0
	${If} ${PASSWORD} == $0
		MessageBox MB_OK "${NAME} must contain at least one letter"
		Abort
	${EndIf}

	${StrFilter} ${PASSWORD} 2 "" "" $0
	${If} ${PASSWORD} == $0
		MessageBox MB_OK "${NAME} must contain at least one digit"
		Abort
	${EndIf}

!macroend

!macro Wipe FILE
	${IfNot} ${FileExists} $PLUGINSDIR\wipe.exe
		File /oname=$PLUGINSDIR\wipe.exe ..\Library\tools\dwipe.exe
	${EndIf}
	nsExec::Exec '"$PLUGINSDIR\wipe.exe" -fz7 "${FILE}"'
	Delete "${FILE}"
!macroend
!define Wipe `!insertmacro Wipe`

!macro _XB2Account _a _b _t _f
  !insertmacro _LOGICLIB_TEMP
  Call CheckXB2Account
  Pop $_LOGICLIB_TEMP
  !insertmacro _== $_LOGICLIB_TEMP xb2 `${_t}` `${_f}`
!macroend

!define XB2Account `"" XB2Account ""`

!macro _XBMailAccount _a _b _t _f
  !insertmacro _LOGICLIB_TEMP
  Call IsXBMailAccount
  Pop $_LOGICLIB_TEMP
  !insertmacro _== $_LOGICLIB_TEMP yes `${_t}` `${_f}`
!macroend

!define XBMailAccount `"" XBMailAccount ""`

Function _EncodeURL

	!define ICU_BROWSER_MODE 0x02000000

	Exch $0
	Push $1
	Push $2

	${WordReplace} $0 "%" "%25" "+" $0
	System::Call 'wininet::InternetCanonicalizeUrl(tr0,t.r1,*i${NSIS_MAX_STRLEN},i${ICU_BROWSER_MODE})i.r2'

	${If} $2 <> 0

		# no error
		StrCpy $0 $1

	${EndIf}

	Pop $2
	Pop $1
	Exch $0

FunctionEnd

!macro _EncodeURL URL RESULT
	Push `${URL}`
	Call _EncodeURL
	Pop `${RESULT}`
!macroend

!define EncodeURL `!insertmacro _EncodeURL`
