Function IsXBMailAccount

	StrCmp $ACCOUNT_TYPE XBPRO yes
	StrCmp $ACCOUNT_TYPE XBPLUS yes
	StrCmp $ACCOUNT_TYPE XBACCESS yes

	Push "no"
	Return

yes:

	Push "yes"

FunctionEnd

Function GetMailCredentials

	${UpdateBanner} "Downloading xB Mail files..."

	${IfNot} ${XBMailAccount}

		Return

	${EndIf}

	${If} ${XB2Account}

		${If} $PIN == ""

			Call CheckPINExists

		${Else}

			Call GetMailCredentialsXB2

		${EndIf}

	${Else}

		StrCpy $PIN "xero"
		${EncodeURL} $PIN $PIN_ENCODED

		Call GetMailCredentialsXB1

	${EndIf}

FunctionEnd

Function GetMailCredentialsXB1

	${Download} "${MAIL_XB1_URL}" $PLUGINSDIR\mailreg.dat

	${If} $DOWNLOAD_RESULT != "OK"

		${Wipe} $PLUGINSDIR\mailreg.dat

		MessageBox MB_ICONSTOP "Error retrieving xB Mail credentials. Please manually set the username and password as documented online."
		StrCpy $MAIL_ALIAS "___XXXX___ERROR___"

		Return

	${EndIf}

	FileOpen $0 $PLUGINSDIR\mailreg.dat r
	FileRead $0 $1
	FileRead $0 $1
	FileRead $0 $1
	FileRead $0 $1
	FileRead $0 $1
	FileRead $0 $1
	FileRead $0 $1
	FileClose $0

	${Wipe} $PLUGINSDIR\mailreg.dat

	${If} $1 == ""

		MessageBox MB_ICONSTOP "Error retrieving xB Mail credentials. Please manually set the username and password as documented online."
		StrCpy $MAIL_ALIAS "___XXXX___ERROR___"

		Return

	${EndIf}

	${WordFind2X} $1 "E-Mail Username:</b></td><td>" "</td>" "+1" $MAIL_USERNAME
	${WordFind2X} $1 "E-Mail Password:</b></td><td>" "</td>" "+1" $MAIL_PASSWORD

	${StrFilter} $MAIL_USERNAME "12" "" "" $0
	${If} $0 != $MAIL_USERNAME

		StrCpy $MAIL_USERNAME ""
		StrCpy $MAIL_PASSWORD ""

		MessageBox MB_ICONSTOP "Error retrieving xB Mail credentials. Please manually set the username and password as documented online."
		StrCpy $MAIL_ALIAS "___XXXX___ERROR___"

		Return

	${EndIf}

	# XXX where does $MAIL_ALIAS come from?
	StrCpy $MAIL_ALIAS "XeroBank"

FunctionEnd

Function GetMailCredentialsXB2

	${Download} "${MAIL_CREATE_URL1}" $PLUGINSDIR\mailcreate.dat # make sure there is a box
	${Download} "${MAIL_XB2_URL}" $PLUGINSDIR\mailreg.dat

	${If} $DOWNLOAD_RESULT != "OK"

		${Wipe} $PLUGINSDIR\mailreg.dat

		Return

	${EndIf}

	FileOpen $0 $PLUGINSDIR\mailreg.dat r # XXX fix according to API
	FileRead $0 $1
	FileClose $0

	${Wipe} $PLUGINSDIR\mailreg.dat

	StrCpy $0 $1 5
	${If} $0 == "ERROR"

		Return

	${EndIf}

	${WordFind2X} $1 '"login":"' '"' "+1" $MAIL_USERNAME
	${WordFind2X} $1 '"password":"' '"' "+1" $MAIL_PASSWORD
	${WordFind2X} $1 '"LocalPart":"' '"' "+1" $MAIL_ALIAS

	${If} $1 == $MAIL_USERNAME

		StrCpy $MAIL_USERNAME ""

	${EndIf}

	${If} $1 == $MAIL_PASSWORD

		StrCpy $MAIL_PASSWORD ""

	${EndIf}

	${If} $1 == $MAIL_ALIAS

		StrCpy $MAIL_ALIAS ""

	${EndIf}

FunctionEnd

Function CreateMail

	${Download} "${MAIL_CREATE_URL2}" $PLUGINSDIR\mailcreate.dat

	${If} $DOWNLOAD_RESULT != "OK"

		${Wipe} $PLUGINSDIR\mailcreate.dat

		Return

	${EndIf}

	FileOpen $0 $PLUGINSDIR\mailcreate.dat r
	FileRead $0 $1
	FileClose $0

	${Wipe} $PLUGINSDIR\mailcreate.dat

	StrCpy $0 $1 5

FunctionEnd

Function CreateSignon

	${IfNot} ${XBMailAccount}
	${OrIf} $MAIL_ALIAS == "___XXXX___ERROR___"
	${OrIf} $MAIL_ALIAS == ""
	${OrIf} $PIN == ""

		Return

	${EndIf}

	SetOutPath "$INSTDIR\App\Mail\thunderbird" # for DLL files

	# initialize password database files (secmod.db, cert8.db and key3.db)
	StrCpy $R0 "$INSTDIR\Data\Mail\profile"
	CreateDirectory $R0

	System::Call 'nss3::NSS_Initialize(t R0, t "", t "", t "secmod.db", i 0) i .r0'

	${If} $0 != 0
		MessageBox MB_OK|MB_ICONSTOP "Password database initialization failed."
		Return
	${EndIf}

	# add "Builtin Roots Module" module
	StrCpy $R0 "$OUTDIR\nssckbi.dll"

	System::Call 'nss3::SECMOD_AddNewModule(t "Builtin Roots Module", t R0, i 0, i 0) i .r0'

	${If} $0 != 0
		MessageBox MB_OK|MB_ICONSTOP "Addition of new password module failed."
		Return
	${EndIf}

	# change master password
	StrCpy $R0 $PIN

	System::Call 'nss3::PK11_FindSlotByName(t "NSS Certificate DB") i .R1'

	${If} $R1 = 0
		MessageBox MB_OK|MB_ICONSTOP "Unable to find appropriate password token."
		Return
	${EndIf}

	System::Call 'nss3::PK11_InitPin(i R1, i 0, t R0) i .r0'
	System::Call 'nss3::PK11_FreeSlot(i R1)'

	${If} $0 != 0
		MessageBox MB_OK|MB_ICONSTOP "Unable to set master password."
		Return
	${EndIf}

	# encrypt empty username
	System::Call '*(i 0, i 0, i 0) i .R0' # keyid
	System::Call '*(&t "") i .R1' # username
	System::Call '*(i 0, i R1, i 0) i .R2' # request
	System::Call '*(i 0, i 0, i 0) i .R3' # reply

	${If} $R0 = 0
	${OrIf} $R1 = 0
	${OrIf} $R2 = 0
	${OrIf} $R3 = 0
		MessageBox MB_OK|MB_ICONSTOP "Memory allocation error while encrypting username."
		Return
	${EndIf}

	System::Call 'nss3::PK11SDR_Encrypt(i R0, i R2, i R3, i 0) i .r0'

	System::Free $R0
	System::Free $R1
	System::Free $R2

	${If} $0 != 0
		MessageBox MB_OK|MB_ICONSTOP "Error encrypting username."
		System::Free $R3
		Return
	${EndIf}

	System::Call '*$R3(i, i .r0, i .r1)'
	System::Call 'plc4::PL_Base64Encode(i r0, i r1, t .r2)'

	System::Call 'nss3::SECITEM_FreeItem(i R3, i 0)'
	System::Free $R3

	# encrypt password
	System::Call '*(i 0, i 0, i 0) i .R0' # keyid
	StrLen $R2 $MAIL_PASSWORD
	System::Call '*(&t$R2 s) i .R1' $MAIL_PASSWORD # password
	System::Call '*(i 0, i R1, i R2) i .R2' # request
	System::Call '*(i 0, i 0, i 0) i .R3' # reply

	${If} $R0 = 0
	${OrIf} $R1 = 0
	${OrIf} $R2 = 0
	${OrIf} $R3 = 0
		MessageBox MB_OK|MB_ICONSTOP "Memory allocation error while encrypting credentials."
		Return
	${EndIf}

	System::Call 'nss3::PK11SDR_Encrypt(i R0, i R2, i R3, i 0) i .r0'

	System::Free $R0
	System::Free $R1
	System::Free $R2

	${If} $0 != 0
		MessageBox MB_OK|MB_ICONSTOP "Error encrypting credentials."
		System::Free $R3
		Return
	${EndIf}

	System::Call '*$R3(i, i .r0, i .r1)'
	System::Call 'plc4::PL_Base64Encode(i r0, i r1, t .r3)'

	System::Call 'nss3::SECITEM_FreeItem(i R3, i 0)'
	System::Free $R3

	# create signons file

	FileOpen $0 "$INSTDIR\Data\Mail\profile\${SIGNONFILE}" w
	${If} $0 = 0
		MessageBox MB_OK|MB_ICONSTOP "Unable to create encrypted credentials file."
		Return
	${EndIf}

	FileWrite $0 "#2c$\n" ; <2.0.0.1 format. Still considered valid.
	FileWrite $0 ".$\n"
	FileWrite $0 "mailbox://$MAIL_ALIAS@xeromail.com$\n"
	FileWrite $0 "\=username=\$\n"
	FileWrite $0 "~$2$\n"
	FileWrite $0 "*\=password=\$\n"
	FileWrite $0 "$3$\n"
	FileWrite $0 ".$\n"

	FileClose $0

FunctionEnd

Function SetupPrefsJS

	FileOpen $0 $INSTDIR\Data\Mail\profile\prefs.js a
	${If} $0 = 0
		Return
	${EndIf}

	FileSeek $0 0 END

	# XXX add the real stuff here

	FileWrite $0 `user_pref("mail.identity.id1.useremail", "$MAIL_ALIAS@xeromail.com");$\n`
	#use $MAIL_USERNAME as username

	FileClose $0

FunctionEnd
