Function Register

	Call DisableVPNComponent

	${If} $REG_TYPE == "free"
		Return
	${EndIf}

	EnableWindow $HWNDPARENT 0
	Banner::show /NOUNLOAD /set 76 "XeroBank Installer Status" "Initializing connection..."

	${StrFilter} $REG 12 "" "" $REG # remove dashes and other signs

	DetailPrint "Downloading config files..." 
	CreateDirectory "$INSTDIR\Data\XeroBank"
	Call CheckAccountType
	${If} $ACCOUNT_TYPE == "XBPLUS"
		${UpdateBanner} "Account Type: SSH"
		DetailPrint "SSH Account Discovered"
		Call AcquireCredentials	; Check to see if files downloaded
	${ElseIf} $ACCOUNT_TYPE == "XBPRO"
		${UpdateBanner} "Account Type: VPN"
		DetailPrint "VPN Account Discovered"
		Call AcquireCredentials
		Call EnableVPNComponent
	${ElseIf} $ACCOUNT_TYPE == "XBACCESS"
		${UpdateBanner} "Access Account Found"
		DetailPrint "Access Account Discovered"
		Call AcquireCredentials
		Call EnableVPNComponent
	${ElseIf} $ACCOUNT_TYPE == "XBDEPOSIT"
		${UpdateBanner} "Deposit Account Found"
		MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "This is a Deposit card. Please use your Access card number."
		DetailPrint "Deposit Account Discovered"
		Call RegisterAbort
	${ElseIf} $ACCOUNT_TYPE == "ERROR"
		${UpdateBanner} "Bad Transation ID: $REG"
		MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "Bad Transaction ID"
		DetailPrint "Error: Bad Transaction ID: $REG"
		Call RegisterAbort
	${ElseIf} $ACCOUNT_TYPE == "CONNECTIONERROR"
		${UpdateBanner} "Account Validation Error"
		MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "Error Validating Your Account. Check Connection/Proxy Settings."
		DetailPrint "Error: Connection Error: $REG"
		Call CheckForFirewall
		Call RegisterAbort
	${ElseIf} $ACCOUNT_TYPE == "NOSUCH"  ; THIS IS WHERE WE NEED TO INSTALL XB 2.0 TRANSID CHECKING
		${UpdateBanner} "Checking XB 2.0 Network"

		# not xb 2.0 key and invalid
		${IfNot} ${XB2Account}
			${UpdateBanner} "Invalid Transaction ID"
			MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "Invalid Transaction ID"
			DetailPrint "Error: Invalid Transaction ID: $REG"
			Call RegisterAbort
		${EndIf}

		# xerobank 2.0 handling
		Call RegisterXB2

	${Else}
		${UpdateBanner} "Unknown Account Type"
		MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "Unknown Account Type."
		Call RegisterAbort
	${EndIf}
	Sleep 1000

	Call RegisterDone
	
FunctionEnd

Function RegisterXB2

	${UpdateBanner} "Checking XB 2.0 Account"

	Call AcquireXB2AccountData
	Call EnableVPNComponent

	StrCpy $ACCOUNT_TYPE "XBPRO"

FunctionEnd

Function RegisterDone

	Banner::destroy
	EnableWindow $HWNDPARENT 1
	BringToFront

FunctionEnd

Function RegisterAbort

	Call RegisterDone
	Abort

FunctionEnd
