Name "Uninstall Info Generator"
OutFile UninstGen.exe

SilentInstall silent

!include LogicLib.nsh
!include FileFunc.nsh

!insertmacro GetParent
!insertmacro Locate

Var INFOFILE
Var LEN

Section

	FileOpen $INFOFILE "$EXEDIR\Uninst.nsh" w
	${If} ${Errors}
		Return
	${EndIf}

	StrLen $LEN $EXEDIR\..\Build
	IntOp $LEN $LEN + 1
	${Locate} "$EXEDIR\..\xBB_Build\App" "" Callback
	${Locate} "$EXEDIR\..\xBB_Build\Data" "" Callback

	StrLen $LEN $EXEDIR\..\xbvpn\Build
	IntOp $LEN $LEN + 1
	${Locate} "$EXEDIR\..\xbvpn\Build\App" "" Callback

	StrLen $LEN $EXEDIR\..\xbmail\Build
	IntOp $LEN $LEN + 1
	${Locate} "$EXEDIR\..\xBM_Build\App" "" Callback
	${Locate} "$EXEDIR\..\xBM_Build\Data" "" Callback

SectionEnd

Function Callback

	; $R9    "path\name"
	; $R8    "path"
	; $R7    "name"
	; $R6    "size"  ($R6="" if directory, $R6="0" if file with /S=)

	Push ""

	StrCpy $R0 $R9 "" $LEN

	StrCpy $R1 $R8 "" -4
	${GetParent} $R8 $R2
	${GetParent} $R2 $R3
	StrCpy $R2 $R2 "" -4
	StrCpy $R3 $R3 "" -4

	${If} $R7 == ".svn"
	${OrIf} $R1 == ".svn"
	${OrIf} $R2 == ".svn"
	${OrIf} $R3 == ".svn"
		Return
	${EndIf}

	${If} $R6 == ""
		FileWrite $INFOFILE `!insertmacro AddUninstallDirEntry "$R0"$\n`
	${Else}
		FileWrite $INFOFILE `!insertmacro AddUninstallFileEntry "$R0"$\n`
	${EndIf}

FunctionEnd
