######################
## Configuration

!define VERSION "2.8.7.2" ; XB2 + year + month + day
!define NAME "XeroBank Setup"
!define MUI_ICON "Installer.ico"
!define MUI_UNICON "UnInstaller.ico"
!define XB_BROWSER "xB Browser"
!define PACKAGEVER "Latest"
!define PACKAGEDIR "..\${PACKAGEVER}"
!define PROGRAM_EXE "xBBrowser.exe"
!define INSTALLATION_DIR "$PROGRAMFILES\XeroBank"
!define COMPANY_NAME "XeroBank"

!define REG_URL https://client.xerobank.com/installer_register.php?username=$USER&password=$PASSWORD&email=$EMAIL
!define CHECK_URL https://software.xerobank.com/data.php?transid=$REG
!define KEYFILE_URL https://software.xerobank.com/data.php?transid=$REG&data=key
!define USERFILE_URL https://software.xerobank.com/data.php?transid=$REG&data=config
!define VPNFILE_URL https://software.xerobank.com/data.php?transid=$REG&data=key ; THIS SHOULD BE CHANGED FOR DISAMBIGUATION FOR XB 2.0!
!define XB2VPN_URL https://activate.xerobank.com/spendAccountAPI/configuration?accountKey=$REG&password=$PIN_ENCODED ; Set $PIN to "" for empty PIN
!define PINEXIST_URL http://activate.xerobank.com/spendAccountAPI/networkAccountData?accountKey=$REG
!define PINTEST_URL http://activate.xerobank.com/spendAccountAPI/networkAccountData?accountKey=$REG&accountPassword=$PIN_ENCODED
!define PINSET_URL http://activate.xerobank.com/spendAccountAPI/changePassword?accountKey=$REG&accountPassword=&newAccountPassword=$PIN_ENCODED
!define MAIL_XB1_URL https://software.xerobank.com/data.php?transid=$REG&data=config
!define MAIL_XB2_URL http://activate.xerobank.com//spendAccountAPI/emailInformation?accountKey=$REG&accountPassword=$PIN_ENCODED
!define MAIL_CREATE_URL1 http://activate.xerobank.com/spendAccountAPI/createEmailAccount?accountKey=$REG&accountPassword=$PIN_ENCODED
!define MAIL_CREATE_URL2 http://activate.xerobank.com/spendAccountAPI/addEmailAlias?accountKey=$REG&accountPassword=$PIN_ENCODED&emailAddress=$MAIL_ALIAS

!define SIGNONFILE xbmail.s

######################
## Files

!define LICENSE license.txt
!define HEADER_BITMAP "xb_box.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP "xerobank.bmp"

######################
## Includes

!include "MUI2.nsh"
!include "LogicLib.nsh"
!include "WordFunc.nsh"
!include "TextFunc.nsh"
!include "NSISArray.nsh"
!include "Sections.nsh"
!include "Versions.nsh"

######################
## Used functions

!insertmacro StrFilter
!insertmacro TrimNewLines
!insertmacro WordFind2X
!insertmacro WordReplace

!insertmacro un.TrimNewLines

######################
## Plug-ins

!addplugindir .

######################
## Settings

Name "XeroBank Setup"
ShowInstDetails show
InstallDir "${INSTALLATION_DIR}"
OutFile "XeroBank Setup.exe"
RequestExecutionLevel admin
SetCompressor /SOLID LZMA
BrandingText "SPECIAL OFFER: Upgrade to High-Speed for $$1"
VIProductVersion "${VERSION}"
VIAddVersionKey FileDescription "$\n xB Browser: ${XB_BROWSER_VERSION}$\n xB VPN: ${XB_VPN_VERSION}$\n xB Mail: ${XB_MAIL_VERSION}"
VIAddVersionKey LegalCopyright "2008 Xero Networks AG"
VIAddVersionKey Comments ""
VIAddVersionKey CompanyName "XeroBank"
VIAddVersionKey OriginalFilename "XeroBank Setup.exe"
VIAddVersionKey FileVersion "${VERSION}"


######################
## Variables

Var PROXY_ADDRESS
Var PROXY_USER
Var PROXY_PASSWORD
Var PROXY_TYPE

Var REG
Var REG_TYPE

Var ACCOUNT_TYPE
Var PIN
Var PIN_ENCODED
Var PIN_EXISTS

Var MAIL_ALIAS
Var MAIL_USERNAME
Var MAIL_PASSWORD

Var FIREWALLRUNNING

Var RETRYCOUNTER
Var RETRYMAX

Var SKIP_REG

Var DIR_IMAGE

Var XBMAILSECTION

######################
## Installer Includes

!include "Macros.nsh"
!include "Credentials.nsh"
!include "Register.nsh"
!include "Mail.nsh"
!include "Certificate.nsh"

######################
## Interface settings

!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "${HEADER_BITMAP}"

!define MUI_ABORTWARNING

!define MUI_CUSTOMFUNCTION_GUIINIT onGUIInit

######################
## Pages

!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "${LICENSE}"

!define MUI_PAGE_CUSTOMFUNCTION_SHOW DirectoryPageShow
!define MUI_PAGE_CUSTOMFUNCTION_LEAVE DirectoryPageLeave
!insertmacro MUI_PAGE_DIRECTORY
	
Page custom RegistrationPage RegistrationPageLeave

!define MUI_PAGE_CUSTOMFUNCTION_PRE  ComponentsPagePre
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ComponentsPageShow
!insertmacro MUI_PAGE_COMPONENTS

# XXX TODO revive once xB Mail is available
#Page custom PinPage PinPageLeave
#Page custom MailAliasPage MailAliasPageLeave

!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_RUN "$INSTDIR\xBVPN.exe"
!define MUI_FINISHPAGE_RUN_TEXT "Run xB VPN"
!define MUI_FINISHPAGE_SHOWREADME
!define MUI_FINISHPAGE_SHOWREADME_FUNCTION Desc_ShortCut
!define MUI_FINISHPAGE_SHOWREADME_TEXT "Create Desktop and Start Menu Shortcuts"
!define MUI_PAGE_CUSTOMFUNCTION_SHOW FinishPageShow
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

######################
## Languages

!insertmacro MUI_LANGUAGE "English"

######################
## UI

ChangeUI IDD_DIR dirbanner-ui.exe

######################
## Initialization

Function .onInit

	StrCpy $PROXY_ADDRESS ""
	StrCpy $PROXY_TYPE "auto"
	StrCpy $PROXY_USER ""
	StrCpy $PROXY_PASSWORD ""
	StrCpy $REG ""
	StrCpy $REG_TYPE "serial"
	StrCpy $RETRYMAX "10"

	# XXX TODO revive once xB Mail is available
	#Call InitXBMailSectionVar
	
FunctionEnd

######################
## Other callbacks

Function .onVerifyInstDir

  # if the main program executable already exists, only upgrade

  ${If} ${FileExists} "$INSTDIR\${PROGRAM_EXE}"
    StrCpy $SKIP_REG "true"
    StrCpy $1 "Upgrade"
  ${Else}
    StrCpy $SKIP_REG ""
    StrCpy $1 "$(^NextBtn)"
  ${EndIf}

  GetDlgItem $0 $HWNDPARENT 1
  SendMessage $0 ${WM_SETTEXT} 0 STR:$1

FunctionEnd

Function onGUIInit

	# Set the hyperlink up

	SectionSetSize "" 34000
	BrandingURL::Set /NOUNLOAD "18" "53" "73" "https://checkout.xerobank.com"

	# Prepare directory banner image

	InitPluginsDir
	File /oname=$PLUGINSDIR\dirbanner.bmp dirbanner.bmp
	File /oname=$PLUGINSDIR\access.bmp "access card.bmp"

	System::Call 'user32::LoadImage(i0, ts, i ${IMAGE_BITMAP}, i0, i0, \
	  i${LR_LOADFROMFILE}|${LR_LOADTRANSPARENT}|${LR_LOADMAP3DCOLORS}) i.s' \
	  $PLUGINSDIR\dirbanner.bmp
	Pop $DIR_IMAGE

FunctionEnd

Function .onGUIEnd

	# Unload the plugin

	BrandingURL::Unload

	# Unload the directory banner image

	System::Call gdi32::DeleteObject(i$DIR_IMAGE)

FunctionEnd

######################
## nsDialogs helpers

!define __NSD_XRadioButtonGroup_CLASS BUTTON
!define __NSD_XRadioButtonGroup_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${BS_TEXT}|${BS_VCENTER}|${BS_AUTORADIOBUTTON}|${BS_MULTILINE}|${WS_GROUP}
!define __NSD_XRadioButtonGroup_EXSTYLE 0

!insertmacro __NSD_DefineControl XRadioButtonGroup

######################
## Page variables

Var RP_FREE
Var RP_SERIAL

Var RP_SERIAL_BOX
Var RP_SERIAL_LABEL
Var RP_SERIAL_NUMBER

Var RP_PROXY_CHECKBOX

Var RP_PX_BOX
Var RP_PX_ADDRESS_LABEL
Var RP_PX_ADDRESS
Var RP_PX_USER_LABEL
Var RP_PX_USER
Var RP_PX_PASSWORD_LABEL
Var RP_PX_PASSWORD

Var PP_PIN
Var PP_PIN2

Var EP_ALIAS

Var RP_BITMAP
Var RP_BITMAP_HANDLE

######################
## Registration Page

Function RegistrationPage

  # skip page, if needed

  ${If} $SKIP_REG == "true"

    Abort

  ${EndIf}

	# set header text

	!insertmacro MUI_HEADER_TEXT "User Registration" "Enter registration information or select free version."

	# create page

	nsDialogs::Create /NOUNLOAD 1018
	Pop $0

	# create controls

	${NSD_CreateLabel} 0 0 100% 24u "Please select your registration type. The Free Version uses the public tor network and XeroBank Member is for clients who already have an account."
	Pop $0

	# version selection

	${NSD_CreateXRadioButtonGroup} 0 26u 100u 12u "&XeroBank Client"
	Pop $RP_SERIAL

	${NSD_CreateRadioButton} 0 40u 100u 12u "&Tor Version"
	Pop $RP_FREE

	${NSD_OnClick} $RP_SERIAL RegistrationPage_Serial
	${NSD_OnClick} $RP_FREE   RegistrationPage_FreeVersion

	# serial

	${NSD_CreateGroupBox} 105u 29u -106u 105u "Access Number or Transaction ID"
	Pop $RP_SERIAL_BOX

	${NSD_CreateLabel} 115u 41u 83u 12u "XeroBank Account:"
	Pop $RP_SERIAL_LABEL

	${NSD_CreateText} 200u 40u 85u 12u "$REG"
	Pop $RP_SERIAL_NUMBER
	ToolTips::Classic $RP_SERIAL_NUMBER "XXXX-XXXX-XXXX-XXXX"

	${NSD_CreateBitmap} 115u 55u 170u 77u ""
	Pop $RP_BITMAP
	${NSD_AddStyle} $RP_BITMAP ${SS_CENTERIMAGE}
	System::Call 'user32::LoadImage(i0, ts, i ${IMAGE_BITMAP}, i0, i0, \
	  i${LR_LOADFROMFILE}|${LR_LOADTRANSPARENT}|${LR_LOADMAP3DCOLORS}) i.s' \
	  $PLUGINSDIR\access.bmp
	Pop $RP_BITMAP_HANDLE
	SendMessage $RP_BITMAP ${STM_SETIMAGE} ${IMAGE_BITMAP} $RP_BITMAP_HANDLE

	# proxy settings

	${NSD_CreateCheckBox} 0 68u 102u 12u "Use custom proxy settings"
	Pop $RP_PROXY_CHECKBOX
	${NSD_OnClick} $RP_PROXY_CHECKBOX RegistrationPage_CustomProxy

	${NSD_CreateGroupBox} 0 82u 100u -84u "Proxy Settings"
	Pop $RP_PX_BOX

	${NSD_CreateLabel} 5u 93u 31u 12u "IP[:port]"
	Pop $RP_PX_ADDRESS_LABEL
	
	${NSD_CreateText} 37u 92u 60u 12u "$PROXY_ADDRESS"
	Pop $RP_PX_ADDRESS
	ToolTips::Classic $RP_PX_ADDRESS "ex: 192.168.0.1:8080"

	${NSD_CreateLabel} 5u 107u 31u 12u "User"
	Pop $RP_PX_USER_LABEL

	${NSD_CreateText} 37u 106u 60u 12u "$PROXY_USER"
	Pop $RP_PX_USER

	${NSD_CreateLabel} 5u 121u 31u 12u "Password"
	Pop $RP_PX_PASSWORD_LABEL

	${NSD_CreateText} 37u 120u 60u 12u "$PROXY_PASSWORD"
	Pop $RP_PX_PASSWORD

	# initialize visibility

	${If} $REG_TYPE == "free"
		SendMessage $RP_FREE ${BM_SETCHECK} ${BST_CHECKED} 0
		Call RegistrationPage_FreeVersion
	${ElseIf} $REG_TYPE == "serial"
		SendMessage $RP_SERIAL ${BM_SETCHECK} ${BST_CHECKED} 0
		Call RegistrationPage_Serial
	${EndIf}

	${If} $PROXY_TYPE == "auto"
		SendMessage $RP_PROXY_CHECKBOX ${BM_SETCHECK} 0 0
	${ElseIf} $PROXY_TYPE == "proxy"
		SendMessage $RP_PROXY_CHECKBOX ${BM_SETCHECK} ${BST_CHECKED} 0
	${EndIf}

	Call RegistrationPage_CustomProxy

	# show the dialog
	nsDialogs::Show

	# clean up resource
	${NSD_FreeImage} $RP_BITMAP_HANDLE

FunctionEnd

Function RegistrationPageLeave
	# save user's settings

	SendMessage $RP_FREE ${BM_GETCHECK} 0 0 $0
	${If} $0 == ${BST_CHECKED}
		StrCpy $REG_TYPE "free"
	${EndIf}

	SendMessage $RP_SERIAL ${BM_GETCHECK} 0 0 $0
	${If} $0 == ${BST_CHECKED}
		StrCpy $REG_TYPE "serial"
	${EndIf}

	SendMessage $RP_PROXY_CHECKBOX ${BM_GETCHECK} 0 0 $0
	${If} $0 == ${BST_CHECKED}
		StrCpy $PROXY_TYPE "proxy"
	${Else}
		StrCpy $PROXY_TYPE "auto"
	${EndIf}

	${NSD_GetText} $RP_SERIAL_NUMBER $REG
	${NSD_GetText} $RP_PX_ADDRESS $PROXY_ADDRESS
	${NSD_GetText} $RP_PX_USER $PROXY_USER
	${NSD_GetText} $RP_PX_PASSWORD $PROXY_PASSWORD

	# validate input
	
	${If} $REG_TYPE == "serial"
		${If} $REG == ""
			# XXX TODO, properly validate serial number
			# my ValidateIP function from the wiki can be adapted to do this, if needed
			MessageBox MB_OK "Serial number is empty!"
			Abort
		${EndIf}
	${EndIf}

	# do the registration

	Call Register

FunctionEnd

Function RegistrationPage_ShowSerial

	ShowWindow $RP_SERIAL_BOX ${SW_SHOW}
	ShowWindow $RP_SERIAL_LABEL ${SW_SHOW}
	ShowWindow $RP_SERIAL_NUMBER ${SW_SHOW}
	ShowWindow $RP_BITMAP ${SW_SHOW}
	EnableWindow $RP_SERIAL_NUMBER 1
	${NSD_SetFocus} $RP_SERIAL_NUMBER

FunctionEnd

Function RegistrationPage_HideSerial

	ShowWindow $RP_SERIAL_BOX ${SW_HIDE}
	ShowWindow $RP_SERIAL_LABEL ${SW_HIDE}
	ShowWindow $RP_SERIAL_NUMBER ${SW_HIDE}
	ShowWindow $RP_BITMAP ${SW_HIDE}
	EnableWindow $RP_SERIAL_NUMBER 0

FunctionEnd

Function RegistrationPage_CustomProxy

	SendMessage $RP_PROXY_CHECKBOX ${BM_GETCHECK} 0 0 $0
	${If} $0 == ${BST_CHECKED}
		Call RegistrationPage_ShowProxy
	${Else}
		Call RegistrationPage_HideProxy
	${EndIf}

FunctionEnd

Function RegistrationPage_ShowProxyCheckbox

	ShowWindow $RP_PROXY_CHECKBOX ${SW_SHOW}
	EnableWindow $RP_PROXY_CHECKBOX 1

	Call RegistrationPage_CustomProxy

FunctionEnd

Function RegistrationPage_HideProxyCheckbox

	ShowWindow $RP_PROXY_CHECKBOX ${SW_HIDE}
	EnableWindow $RP_PROXY_CHECKBOX 0

	Call RegistrationPage_HideProxy

FunctionEnd

Function RegistrationPage_ShowProxy

	ShowWindow $RP_PX_BOX            ${SW_SHOW}
	ShowWindow $RP_PX_ADDRESS_LABEL  ${SW_SHOW}
	ShowWindow $RP_PX_ADDRESS        ${SW_SHOW}
	EnableWindow $RP_PX_ADDRESS      1
	ShowWindow $RP_PX_USER_LABEL     ${SW_SHOW}
	ShowWindow $RP_PX_USER           ${SW_SHOW}
	EnableWindow $RP_PX_USER         1
	ShowWindow $RP_PX_PASSWORD_LABEL ${SW_SHOW}
	ShowWindow $RP_PX_PASSWORD       ${SW_SHOW}
	EnableWindow $RP_PX_PASSWORD     1

FunctionEnd

Function RegistrationPage_HideProxy

	ShowWindow $RP_PX_BOX            ${SW_HIDE}
	ShowWindow $RP_PX_ADDRESS_LABEL  ${SW_HIDE}
	ShowWindow $RP_PX_ADDRESS        ${SW_HIDE}
	EnableWindow $RP_PX_ADDRESS      0
	ShowWindow $RP_PX_USER_LABEL     ${SW_HIDE}
	ShowWindow $RP_PX_USER           ${SW_HIDE}
	EnableWindow $RP_PX_USER         0
	ShowWindow $RP_PX_PASSWORD_LABEL ${SW_HIDE}
	ShowWindow $RP_PX_PASSWORD       ${SW_HIDE}
	EnableWindow $RP_PX_PASSWORD     0

FunctionEnd

Function RegistrationPage_FreeVersion

	Call RegistrationPage_HideSerial
	Call RegistrationPage_HideProxyCheckbox

FunctionEnd

Function RegistrationPage_Serial

	Call RegistrationPage_ShowSerial
	Call RegistrationPage_ShowProxyCheckbox

FunctionEnd

######################
## PIN Page

Function PINPage

	${IfNot} ${XBMailAccount} # not xb mail account
	${OrIfNot} ${XB2Account} # or not xb 2.0
	${OrIfNot} ${SectionIsSelected} $XBMAILSECTION # or doesn't want xb mail

		Abort

	${EndIf}

	# test PIN's existance

	!insertmacro MUI_HEADER_TEXT "PIN Setup" "Enter PIN code information for safe communication."

	nsDialogs::Create /NOUNLOAD 1018
	Pop $0

	${If} $PIN_EXISTS != "true"

		${NSD_CreateLabel} 0 0 100% 24u "xB Mail is installed, but you haven't set a PIN code. Please select a PIN code for your account and type it twice for verification."
		Pop $0

		${NSD_CreateGroupBox} 50u 28u -139u 50u ""
		Pop $0

		${NSD_CreateLabel} 58u 41u 37u 12u "PIN Code"
		Pop $0

		${NSD_CreatePassword} 100u 40u 100u 12u ""
		Pop $PP_PIN
		${NSD_SetFocus} $PP_PIN

		${NSD_CreateLabel} 58u 59u 37u 12u "Repeat"
		Pop $0

		${NSD_CreatePassword} 100u 58u 100u 12u ""
		Pop $PP_PIN2

	${Else}

		${NSD_CreateLabel} 0 0 100% 24u "xB Mail requires your PIN code to encrypt your credentials. Please type in your PIN code below."
		Pop $0

		${NSD_CreateGroupBox} 50u 28u -139u 30u ""
		Pop $0

		${NSD_CreateLabel} 58u 41u 37u 12u "PIN Code"
		Pop $0

		${NSD_CreatePassword} 100u 40u 100u 12u ""
		Pop $PP_PIN
		${NSD_SetFocus} $PP_PIN

	${EndIf}

	nsDialogs::Show

FunctionEnd

Function PINPageLeave

	${If} $PIN_EXISTS == "false"

		Call PINPageLeaveNewPIN

	${Else}

		Call PINPageLeaveExistingPIN

	${EndIf}

FunctionEnd

Function PINPageLeaveExistingPIN

	${NSD_GetText} $PP_PIN $PIN
	${EncodeURL} $PIN $PIN_ENCODED

	${If} $PIN == ""

		MessageBox MB_ICONSTOP "Specified PIN code is empty."
		${NSD_SetFocus} $PP_PIN

		Abort

	${EndIf}

	EnableWindow $HWNDPARENT 0
	Banner::show /NOUNLOAD /set 76 "XeroBank PIN Setup Status" "Checking validity of PIN..."

	Call TestPIN

	${If} $0 == "good pin"

		Call GetMailCredentials

		StrCpy $0 "good pin" # revert to SetPIN's result, we'll check if it worked later

	${EndIf}

	Banner::destroy

	EnableWindow $HWNDPARENT 1

	${If} $0 != "good pin"

		MessageBox MB_ICONSTOP "Incorrect PIN code specified. Please try again."
		${NSD_SetFocus} $PP_PIN

		Abort

	${EndIf}

FunctionEnd

Function PINPageLeaveNewPIN

	${NSD_GetText} $PP_PIN $0
	${NSD_GetText} $PP_PIN2 $PIN
	${EncodeURL} $PIN $PIN_ENCODED

	${If} $0 != $PIN

		MessageBox MB_ICONSTOP "PIN codes don't match. Make sure you've typed the same PIN code in both boxes."
		${NSD_SetFocus} $PP_PIN

		Abort

	${EndIf}

	!insertmacro CheckPasswordStrength $PIN PIN

	EnableWindow $HWNDPARENT 0
	Banner::show /NOUNLOAD /set 76 "XeroBank PIN Setup Status" "Sending new PIN code to server..."

	Call SetPIN

	${If} $0 == "success"

		Call GetMailCredentials

		StrCpy $0 "success" # revert to SetPIN's result, we'll check if it worked later

	${EndIf}

	Banner::destroy

	EnableWindow $HWNDPARENT 1

	${If} $0 != "success"

		MessageBox MB_ICONSTOP "Unable to set PIN. Please try again.$\r$\n$\r$\n$0"
		${NSD_SetFocus} $PP_PIN

		Abort

	${EndIf}

FunctionEnd

######################
## Mail Alias Page

Function MailAliasPage

	${IfNot} ${XBMailAccount} # not xb mail account
	${OrIfNot} ${XB2Account} # or not xb 2.0
	${OrIfNot} ${SectionIsSelected} $XBMAILSECTION # or doesn't want xb mail
	${OrIf} $MAIL_ALIAS != "" # or already has an alias

		Abort

	${EndIf}

	!insertmacro MUI_HEADER_TEXT "Mail Setup" "Enter xB Mail information for automated setup."

	nsDialogs::Create /NOUNLOAD 1018
	Pop $0

	${NSD_CreateLabel} 0 0 100% 24u "xB Mail is installed, but you haven't created a XeroBank e-mail account yet. Please select a username for your @xeromail.com address."
	Pop $0

	${NSD_CreateGroupBox} 30u 28u -110u 31u "Username"
	Pop $0

	${NSD_CreateText} 40u 40u -180u 12u ""
	Pop $EP_ALIAS
	${NSD_SetFocus} $EP_ALIAS

	${NSD_CreateLabel} 163u 41u 50u 12u "@xeromail.com"
	Pop $0

	nsDialogs::Show

FunctionEnd

Function MailAliasPageLeave

	${NSD_GetText} $EP_ALIAS $MAIL_ALIAS

	${StrFilter} $MAIL_ALIAS 12 "" "" $0
	${If} $MAIL_ALIAS != $0

		MessageBox MB_OK "Username must contain only digits and letters"
		${NSD_SetFocus} $EP_ALIAS

		Abort

	${EndIf}

	EnableWindow $HWNDPARENT 0
	Banner::show /NOUNLOAD /set 76 "XeroBank Mail Setup Status" "Creating new mail address..."

	Call CreateMail

	${If} $0 != "error"

		${If} $0 != "TAKEN"

			Call GetMailCredentials

			${If} $MAIL_ALIAS == ""

				StrCpy $MAIL_ALIAS "___XXXX___ERROR___"

			${EndIf}

		${Else}

			MessageBox MB_OK "$MAIL_ALIAS@xeromail.com is already taken. Please choose another alias."

			StrCpy $MAIL_ALIAS ""

		${EndIf}

	${Else}

		MessageBox MB_ICONSTOP "Error creating xB Mail address. Please manually set the username and password as documented online."
		StrCpy $MAIL_ALIAS "___XXXX___ERROR___"

	${EndIf}

	Banner::destroy

	EnableWindow $HWNDPARENT 1

	${If} $MAIL_ALIAS == ""

		${NSD_SetFocus} $EP_ALIAS

		Abort

	${EndIf}

FunctionEnd

######################
## Installation

Section "!${XB_BROWSER} ${XB_BROWSER_VERSION}" SEC_BROWSER

	SectionIn RO

!ifndef XB_DEBUG

	DetailPrint "Extracting Files..."
	SetOutPath $INSTDIR ; temporarily set output path temp dir to extract the data.
	File "${PACKAGEDIR}\${PROGRAM_EXE}"
	SetOutPath "$INSTDIR\Data"
	File /r /x .svn "..\xBB_Build\Data\*.*"
	SetOutPath "$INSTDIR\App"
	File /r /x .svn "..\xBB_Build\App\*.*"
	SetOutPath "$INSTDIR"
	File change.log
	
	${If} ${XB2Account}
	${OrIf} $ACCOUNT_TYPE == "XBVPN"
	${OrIf} $ACCOUNT_TYPE == "XBPRO"
		Delete $INSTDIR\Data\Browser\profile\bookmarks.html
		Rename $INSTDIR\Data\Browser\profile\bookmarks.paid.html $INSTDIR\Data\Browser\profile\bookmarks.html
	${EndIf}
	
;	File 7za.exe ;extract the extractor to temp
;	Sleep 3000 ;Sometimes extracting takes some time...
;	${If} ${FileExists} "$PLUGINSDIR\data.7z"
;		SetOutPath $INSTDIR
;		DetailPrint "Installing Files..."
;		ExecDos::exec /NOUNLOAD /DETAILED `"$PLUGINSDIR\7za.exe" x -y "$PLUGINSDIR\data.7z"` "" ""
;		DetailPrint "File Installation Complete"
;		Delete "$PLUGINSDIR\data.7z"
;		Delete "$PLUGINSDIR\7za.exe"
;		Sleep 1000
;	${Else}
;		DetailPrint "!!!Error Extracting Payload!!!"
;		MessageBox MB_OK|MB_TOPMOST "Error Extracting Payload. Make sure you have enough space$\rand write access to $PLUGINSDIR"
;		Abort
;	${EndIf}

!endif #!XB_DEBUG

	Call ReadCACert
	DetailPrint "Adding CACert root certificate..."
	Call AddCACert
	Call FreeCACert

SectionEnd

Section /o "" SEC_VPN

	SectionIn RO

!ifndef XB_DEBUG

	SetOutPath $INSTDIR
	File ..\xbvpn\Latest\xBVPN.exe

	SetOutPath $INSTDIR\App
	File /r /x .svn ..\xbvpn\Build\App\*.*

	CreateShortcut "$SMSTARTUP\xB VPN.lnk" $INSTDIR\xBVPN.exe

!endif #!XB_DEBUG

SectionEnd

Function DisableVPNComponent

	!insertmacro UnselectSection ${SEC_VPN}
	SectionSetText ${SEC_VPN} ""

FunctionEnd

Function EnableVPNComponent

	!insertmacro SelectSection ${SEC_VPN}
	SectionSetText ${SEC_VPN} "xB VPN ${XB_VPN_VERSION}"

FunctionEnd

Function FinishPageShow

	${IfNot} ${SectionIsSelected} ${SEC_VPN}

		${NSD_Uncheck} $mui.FinishPage.Run
		EnableWindow $mui.FinishPage.Run 0

	${EndIf}

FunctionEnd

# XXX TODO revive once xB Mail is available
/*
Section "xB Mail ${XB_MAIL_VERSION}" SEC_MAIL

!ifndef XB_DEBUG

	SetOutPath $INSTDIR
	File ..\xbmail\Latest\xBMail.exe

	SetOutPath $INSTDIR\App
	File /r /x .svn ..\xBM_Build\App\*.*

	SetOutPath $INSTDIR\Data
	File /r /x .svn ..\xBM_Build\Data\*.*

!endif #!XB_DEBUG

	Call CreateSignon
	Call SetupPrefsJS
	
SectionEnd

Function InitXBMailSectionVar

	StrCpy $XBMAILSECTION ${SEC_MAIL}

FunctionEnd
*/
Function ComponentsPagePre

	${If} ${XB2Account}
	${OrIf} $ACCOUNT_TYPE == "XBVPN"
	${OrIf} $ACCOUNT_TYPE == "XBPRO"

		!insertmacro ClearSectionFlag ${SEC_BROWSER} ${SF_BOLD}
		!insertmacro ClearSectionFlag ${SEC_BROWSER} ${SF_RO}

	${Else}

		!insertmacro SetSectionFlag ${SEC_BROWSER} ${SF_BOLD}
		!insertmacro SetSectionFlag ${SEC_BROWSER} ${SF_RO}

	${EndIf}

FunctionEnd

Function ComponentsPageShow

	Call .onSelChange

FunctionEnd

Function .onSelChange
# XXX TODO revive once xB Mail is available
/*
	GetDlgItem $0 $HWNDPARENT 1

	${If} ${XBMailAccount} # only xb mail accounts
	${AndIf} ${XB2Account} # which are xb 2.0
	${AndIf} ${SectionIsSelected} ${SEC_MAIL} # and selected xb mail
		SendMessage $0 ${WM_SETTEXT} "" "STR:$(^NextBtn)" # should get the configuration pages
	${Else}
		SendMessage $0 ${WM_SETTEXT} "" "STR:$(^InstallBtn)"
	${EndIf}
*/
FunctionEnd

${Array} "UninstallInfo" 100 ${NSIS_MAX_STRLEN}
${ArrayFunc} Shift
${ArrayFunc} ReadFirst
${ArrayFunc} ReadNext
${ArrayFunc} ReadClose
${ArrayFunc} Search

${Array} "un.UninstallInfo" 100 ${NSIS_MAX_STRLEN}
${ArrayFunc} Shift
${ArrayFunc} ReadFirst
${ArrayFunc} ReadNext
${ArrayFunc} ReadClose
${ArrayFunc} Reverse
${ArrayFunc} Search
${ArrayFunc} Sort

Section Uninstaller SEC_UNINST

	# initialize uninstall information
	${UninstallInfo->Init}

	# create uninstall data directory
	CreateDirectory $INSTDIR\Data\Uninstall

	# read old information
	Call ReadUninstallInfo

	# add new entries
	Call UpdateUninstallInfo

	# write new information to file
	Call WriteUninstallInfo

	# delete array
	${UninstallInfo->Delete}

	# create uninstaller
	WriteUninstaller "$INSTDIR\XeroBank Uninstaller.exe"

SectionEnd

!macro ReadUninstallInfo UN

	ClearErrors
	FileOpen $0 "$INSTDIR\Data\Uninstall\${XB_BROWSER}.uni" "r"
	${IfNot} ${Errors}
		${Do}
			FileRead $0 $1
			${${UN}TrimNewLines} $1 $1
			${If} $1 != ""
				${${UN}UninstallInfo->Shift} $1
			${Else}
				${Break}
			${EndIf}
		${Loop}
		FileClose $0
	${EndIf}

!macroend

Function ReadUninstallInfo

	!insertmacro ReadUninstallInfo ""

FunctionEnd

Function un.ReadUninstallInfo

	!insertmacro ReadUninstallInfo "un."

FunctionEnd

Function WriteUninstallInfo

	##### WARNING
	#
	#      Do no change the .uni filename.
	#      It must stay the same so files from older versions
	#      will get deleted using new uninstallers.
	#  
	#####

	ClearErrors
	FileOpen $0 "$INSTDIR\Data\Uninstall\${XB_BROWSER}.uni" "w"
	${If} ${Errors}
		Return
	${EndIf}

	ClearErrors
	${UninstallInfo->ReadFirst} $1 $2
	${DoUntil} ${Errors}
		FileWrite $0 $2$\r$\n
		ClearErrors
		${UninstallInfo->ReadNext} $1 $2
	${Loop}
	${UninstallInfo->ReadClose} $1

	FileClose $0

FunctionEnd

Function AddUninstallEntry

	# check if already exists
	${UninstallInfo->Search} $R0 $0 0
	${If} $R0 == -1
		${UninstallInfo->Shift} $0
	${EndIf}

FunctionEnd

!macro AddUninstallFileEntry FILE

	StrCpy $0 "F${FILE}"
	Call AddUninstallEntry

!macroend

!macro AddUninstallDirEntry DIR

	StrCpy $0 "D${DIR}"
	Call AddUninstallEntry

!macroend

Function UpdateUninstallInfo

	!insertmacro AddUninstallFileEntry "${PROGRAM_EXE}"

	${If} ${FileExists} $INSTDIR\xBVPN.exe
		!insertmacro AddUninstallFileEntry "xBVPN.exe"
	${EndIf}

	${If} ${FileExists} $INSTDIR\xBMail.exe
		!insertmacro AddUninstallFileEntry "xBMail.exe"
	${EndIf}

	!insertmacro AddUninstallDirEntry "App"
	!insertmacro AddUninstallDirEntry "Data"

	!system UninstGen.exe
	!include Uninst.nsh
	!delfile Uninst.nsh

FunctionEnd

Function CheckForFirewall

		Firewall-Disabler::QueryFirewall
		Pop $FIREWALLRUNNING

		${If} ${ProcessRunning} "ccapp.exe"
		${OrIf} ${ProcessRunning} "zapro.exe"
		${OrIf} ${ProcessRunning} "armor2net.exe"
		${OrIf} ${ProcessRunning} "amon.exe"
		${OrIf} ${ProcessRunning} "MpfService.exe"
		${OrIf} ${ProcessRunning} "zonealarm.exe"
		${OrIf} ${ProcessRunning} "outpost.exe"
		${OrIf} ${ProcessRunning} "firewall.exe"
		${OrIf} ${ProcessRunning} "atguard.exe"
		${OrIf} ${ProcessRunning} "tpfw.exe"
		${OrIf} ${ProcessRunning} "kpf4ss.exe"
		${OrIf} ${ProcessRunning} "nprotect.exe"
		${OrIf} ${ProcessRunning} "kpf4gui.exe"
		${OrIf} $FIREWALLRUNNING == 1 ;If it is running...
			MessageBox MB_OK|MB_ICONSTOP|MB_TOPMOST "It appears you are running a firewall. This may be the source$\rof the connectivity problems. Please temporarily disable it.$\rIf the problem persists, the XeroBank registration server may be$\rbusy. You can download your key manually by clicking the link at$\rthe bottom left of the installer."
		${Else}
			MessageBox MB_OK|MB_ICONSTOP|MB_TOPMOST "The XeroBank registration server may be busy. Please try again later or$\rlogin and download your keys manually by clicking the link at$\rthe bottom left of the installer."
		${EndIf}
FunctionEnd

Function Desc_Shortcut ;Create the Start menu icons and desktop icons.
SetOutPath "$INSTDIR"

${If} ${SectionIsSelected} ${SEC_BROWSER}
	CreateShortCut "$DESKTOP\${XB_BROWSER}.lnk" "$INSTDIR\${PROGRAM_EXE}"
	CreateDirectory "$SMPROGRAMS\XeroBank"
	CreateShortCut "$SMPROGRAMS\XeroBank\${XB_BROWSER}.lnk" "$INSTDIR\${PROGRAM_EXE}"
	CreateShortCut "$SMPROGRAMS\XeroBank\${XB_BROWSER} Debug Mode.lnk" "$INSTDIR\${PROGRAM_EXE}" /log
	CreateShortCut "$SMPROGRAMS\XeroBank\xB Config.lnk" "$INSTDIR\App\xBConfig.exe"
${EndIf}

	CreateShortCut "$SMPROGRAMS\XeroBank\XeroBank Uninstaller.lnk" "$INSTDIR\XeroBank Uninstaller.exe"

;Mail Links
# XXX TODO revive once xB Mail is available
/*
${If} ${SectionIsSelected} ${SEC_MAIL}
	CreateShortCut "$DESKTOP\xb Mail.lnk" "$INSTDIR\xBMail.exe"
	CreateShortcut "$SMPROGRAMS\XeroBank\xB Mail.lnk" "$INSTDIR\xBMail.exe"
${EndIf}
*/
;VPN Links in addition to Start Menu
${If} ${SectionIsSelected} ${SEC_VPN}
	CreateShortcut "$SMPROGRAMS\XeroBank\xB VPN.lnk" "$INSTDIR\xBVPN.exe"
${EndIf}

FunctionEnd

Function DirectoryPageShow

	FindWindow $R0 "#32770" "" $HWNDPARENT
	GetDlgItem $R0 $R0 1007
	SendMessage $R0 ${STM_SETIMAGE} ${IMAGE_BITMAP} $DIR_IMAGE

FunctionEnd

Function DirectoryPageLeave
  CreateDirectory $INSTDIR
  ClearErrors
  FileOpen $R0 $INSTDIR\temp.tmp a
  FileClose $R0
  Delete $INSTDIR\temp.tmp
  ${If} ${Errors}
    MessageBox MB_OK|MB_ICONSTOP "You Do Not Have Access to Write to $INSTDIR."
    Abort
  ${EndIf}
FunctionEnd

######################
## Uninstall

Function un.onInit

	# make sure the information exists
	${IfNot} ${FileExists} "$INSTDIR\Data\Uninstall\${XB_BROWSER}.uni"
		MessageBox MB_OK|MB_ICONSTOP "Uninstall information file missing!$\n$\n$INSTDIR\Data\Uninstall\${XB_BROWSER}.uni"
		Abort
	${EndIf}

	# make sure the program isn't still running
	${If} ${ProcessRunning} "${PROGRAM_EXE}"
		MessageBox MB_OK|MB_ICONSTOP "${PROGRAM_EXE} is still running. Please shut it down and try uninstalling again."
		Abort
	${EndIf}

FunctionEnd

Section uninstall

 ; This uninstaller needs to be completed by component.

	# delete shortcuts
	Delete "$DESKTOP\${XB_BROWSER}.lnk"
	Delete "$SMPROGRAMS\XeroBank\${XB_BROWSER}.lnk"

	Delete "$SMPROGRAMS\XeroBank\xB VPN.lnk"
	Delete "$SMSTARTUP\XeroBank\xB VPN.lnk"

	Delete "$DESKTOP\xB Mail.lnk"
	Delete "$SMPROGRAMS\XeroBank\xB Mail.lnk"

	Delete "$SMPROGRAMS\XeroBank\XeroBank Uninstaller.lnk"
	Delete "$SMPROGRAMS\XeroBank\xB Config.lnk"
	Delete "$SMPROGRAMS\XeroBank\${XB_BROWSER} Debug Mode.lnk"
	RMDir "$SMPROGRAMS\XeroBank"

	# initialize uninstall information
	${un.UninstallInfo->Init}

	# read uninstsall data
	Call un.ReadUninstallInfo

	# sort and reverse so folders will be properly deleted
	${un.UninstallInfo->Sort} ""
	${un.UninstallInfo->Reverse}

	# delete data file and folder
	Delete "$INSTDIR\XeroBank Uninstaller.exe"
	Delete "$INSTDIR\Data\Uninstall\${XB_BROWSER}.uni"
	RMDir "$INSTDIR\Data\Uninstall"

	# remove files
	GetFunctionAddress $R9 un.UninstallFile
	Call un.ParseUninstallInfo

	# remove folders
	GetFunctionAddress $R9 un.UninstallFolder
	Call un.ParseUninstallInfo

	# delete array
	${un.UninstallInfo->Delete}

	# try to delete the main folder
	RMDir $INSTDIR

	# delete everything, if no other program is installed
	${IfNot} ${FileExists} $INSTDIR\xB*.exe
		RMDir /r $INSTDIR
	${EndIf}

SectionEnd

Function un.ParseUninstallInfo

	ClearErrors
	${un.UninstallInfo->ReadFirst} $1 $R0
	${DoUntil} ${Errors}
		Call $R9
		ClearErrors
		${un.UninstallInfo->ReadNext} $1 $R0
	${Loop}
	${un.UninstallInfo->ReadClose} $1

FunctionEnd

Function un.UninstallFile

	StrCpy $R1 $R0 1
	${If} $R1 == "F"
		StrCpy $R1 $R0 "" 1
		Delete $INSTDIR\$R1
	${EndIf}

FunctionEnd

Function un.UninstallFolder

	StrCpy $R1 $R0 1
	${If} $R1 == "D"
		StrCpy $R1 $R0 "" 1
		RMDir $INSTDIR\$R1
	${EndIf}

FunctionEnd

