!ifndef ___SPLASH__NSH___
!define ___SPLASH__NSH___

!include LogicLib.nsh
!include WinMessages.nsh

Var BGIMAGE

!macro _SplashCheckDefine DEFINE

	!ifndef ${DEFINE}

		!error "${DEFINE} is undefined!"

	!endif

!macroend

!macro _SplashFont

	!ifndef _SPLASH_FONT_VAR_

		!define _SPLASH_FONT_VAR_
		Var /GLOBAL _SPLASH_FONT_VAR_

		!insertmacro _SplashCheckDefine SPLASH_TEXT_FONT
		!insertmacro _SplashCheckDefine SPLASH_TEXT_SIZE
		!insertmacro _SplashCheckDefine SPLASH_TEXT_WEIGHT

	!endif

	${If} $_SPLASH_FONT_VAR_ == ""

		CreateFont $_SPLASH_FONT_VAR_ "${SPLASH_TEXT_FONT}" ${SPLASH_TEXT_SIZE} ${SPLASH_TEXT_WEIGHT}

	${EndIf}

!macroend

!macro SplashInit BITMAP

	InitPluginsDir
	File /oname=$PLUGINSDIR\splash-base.bmp "${BITMAP}"
	BgImage::SetBg /NOUNLOAD $PLUGINSDIR\splash-base.bmp

	StrCpy $BGIMAGE "active"

!macroend

!macro SplashSetText TEXT

	${If} $BGIMAGE == "active"

		!insertmacro _SplashCheckDefine SPLASH_TEXT_R
		!insertmacro _SplashCheckDefine SPLASH_TEXT_G
		!insertmacro _SplashCheckDefine SPLASH_TEXT_B
		!insertmacro _SplashCheckDefine SPLASH_TEXT_X1
		!insertmacro _SplashCheckDefine SPLASH_TEXT_Y1
		!insertmacro _SplashCheckDefine SPLASH_TEXT_X2
		!insertmacro _SplashCheckDefine SPLASH_TEXT_Y2

		!insertmacro _SplashCheckDefine SPLASH_VER_R
		!insertmacro _SplashCheckDefine SPLASH_VER_G
		!insertmacro _SplashCheckDefine SPLASH_VER_B
		!insertmacro _SplashCheckDefine SPLASH_VER_X1
		!insertmacro _SplashCheckDefine SPLASH_VER_Y1
		!insertmacro _SplashCheckDefine SPLASH_VER_X2
		!insertmacro _SplashCheckDefine SPLASH_VER_Y2

		!insertmacro _SplashFont

		BgImage::Clear /NOUNLOAD
		BgImage::SetBg /NOUNLOAD $PLUGINSDIR\splash-base.bmp
		BgImage::AddText /NOUNLOAD `v${VER}${SUBVERSION}` $_SPLASH_FONT_VAR_ ${SPLASH_VER_R} ${SPLASH_VER_G} \
			${SPLASH_VER_B} ${SPLASH_VER_X1} ${SPLASH_VER_Y1} ${SPLASH_VER_X2} ${SPLASH_VER_Y2}
		BgImage::AddText /NOUNLOAD `${TEXT}` $_SPLASH_FONT_VAR_ ${SPLASH_TEXT_R} ${SPLASH_TEXT_G} \
			${SPLASH_TEXT_B} ${SPLASH_TEXT_X1} ${SPLASH_TEXT_Y1} ${SPLASH_TEXT_X2} ${SPLASH_TEXT_Y2}
		BgImage::Redraw /NOUNLOAD

	${EndIf}

!macroend

!macro SplashDestroy

	${If} $BGIMAGE == "active"

		!insertmacro _SplashFont

		BgImage::Destroy
		System::Call "user32::DeleteObject(i$_SPLASH_FONT_VAR_)"

		StrCpy $_SPLASH_FONT_VAR_ ""
		StrCpy $BGIMAGE ""

		HideWindow

	${EndIf}

!macroend

!endif #___SPLASH__NSH___
