;Copyright (C) 2008 Xero Networks AG
;All rights reserved by Xero Networks AG
;This software is licensed under the latest version of the Torrify Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.

!include settings.nsh

!include LogicLib.nsh
!include FileFunc.nsh

!insertmacro GetParameters
!insertmacro GetOptions

Name "${NAME} Updater"
Caption $(^Name)
Icon update.ico
OutFile Updater.exe
RequestExecutionLevel user
XPStyle on

!macro Download URL FILE

	${If} $1 != ""
		${If} $2 != ""
			inetc::get "/PROXY $1" /USER $2 /PASSWORD $2 /RESUME "Download was interrupted. Resume download?" "${URL}" "${FILE}" /END
		${Else}
			inetc::get "/PROXY $1" /RESUME "Download was interrupted. Resume download?" "${URL}" "${FILE}" /END
		${EndIf}
	${Else}
		inetc::get /RESUME "Download was interrupted. Resume download?" /NOPROXY "${URL}" "${FILE}" /END
	${EndIf}

	Pop $R0

!macroend

Function .onInit

	${GetParameters} $0
	${GetOptions} $0 /install= $R0
	${GetOptions} $0 /proxy= $1
	${GetOptions} $0 /user= $2
	${GetOptions} $0 /password= $3

	${If} $R0 == "new"
		ExecWait '"$TEMP\New ${NAME} Version.exe"' $R0
		${If} $R0 != 0		
			MessageBox MB_OK "Update failed or cancelled."
		${EndIf}
		Delete "$TEMP\New ${NAME} Version.exe"
		Delete "$TEMP\New ${NAME} Version.exe.sig"
		Delete "$TEMP\New ${NAME} Version.msg"
		Delete "$TEMP\New ${NAME} Version.ver"	
		Abort

	${EndIf}

	InitPluginsDir
	!insertmacro Download "${UPDATEMSG}" "$TEMP\New ${NAME} Version.msg"
	!insertmacro Download "${UPDATELOC}" "$TEMP\New ${NAME} Version.ver"
	!insertmacro Download "${UPDATEURL}" "$TEMP\New ${NAME} Version.exe"
	!insertmacro Download "${UPDATESIG}" "$TEMP\New ${NAME} Version.exe.sig"

	${If} $R0 != "OK"
		${If} $R0 != "Cancelled"
			MessageBox MB_OK|MB_TOPMOST|MB_ICONINFORMATION "Error downloading update.$\r$\n$\r$\n$R0"
		${EndIf}
		Abort
	${EndIf}

	Abort

FunctionEnd

Section
SectionEnd
