;Copyright (C) 2008 Xero Networks AG
;All rights reserved by Xero Networks AG
;This software is licensed under the latest version of the Torrify Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.
;
;

Function LaunchConnectionClient ;Launch whatever the connection should be, tor, XeroBank, etc.
	${DebugHeader} "LaunchConnectionClient: $CONNECTIONSTRING"
	${If} $SUBMISSIVEMODE == true
		${DebugHeader} "		NOTICE: SubmissiveMode is Overriding LaunchConnectionClient. Hopefully this doesn't get stuck in a cycle."
	${Else} ;If we aren't explicitly in submissive mode, and thus are running tor...
		SetOutPath $OUTPATH ;Required, otherwise connectionclient won't launch correctly
		${If} $DEBUGON > 0 ;If we are in debug mode, use exec so a command window is opened, otherwise use execdos to hide the window.
			ExecDos::exec /NOUNLOAD /ASYNC $CONNECTIONSTRING "" "$DESKTOP\${NAME}_Client.log"
		${Else} ;If we aren't in debug mode, use execdos so we don't open a window
			ExecDos::exec /NOUNLOAD /ASYNC $CONNECTIONSTRING "" "$PLUGINSDIR\Connection.log"
		${EndIf}
		${If} $CONNECTIONMETHOD != 0 ;Give the connection 5 seconds to come up.
			${If} $CONNECTIONMETHOD = 1
				Call WaitForConnection
			${Else}
				Sleep 5000
			${EndIf}
		${EndIf}
	${EndIf}
	
FunctionEnd

;Waits until XeroBank Plus is connected
Function WaitForConnection

	${DoUntil} ${TCPPortOpen} 8080
		Sleep 500
		${IfNot} ${IsProcessRunning} $CONNECTIONCLIENT
			# break incase XeroBankPlus.exe died
			${Break}
		${EndIf}
	${Loop}

FunctionEnd

Function CheckKeyFailure

	StrCpy $R0 ""

	# check if died due to key problems
	${LineFind} $PLUGINSDIR\Connection.log /NUL 1:-1 CheckKeyFailureCallback

FunctionEnd

Function CheckKeyFailureCallback

	${TrimNewLines} $R9 $R1

	${If}     $R1 == "Server refused public key"
		StrCpy $R0 "bad key"
		Push StopLineFind
	${ElseIf} $R1 == "The server's host key is not cached in the registry. You"
		StrCpy $R0 "bad fingerprint"
		Push StopLineFind
	${ElseIf} $R1 == "Host does not exist"
		StrCpy $R0 "invalid host"
		Push StopLineFind
	${Else}
		Push ""
	${EndIf}

FunctionEnd

Function PuttyConnectionChecker
	${If} $CONNECTIONMETHOD == 1 ;SSH
		Call CheckKeyFailure
		${If} $R0 == "bad key"
			!insertmacro SplashSetText "Key refused"
			MessageBox MB_ICONSTOP|MB_TOPMOST "Your access key has been refused by the server. Please contact support."
			Call UnloadGUI
		${OrIf} $R0 == "bad fingerprint"
			!insertmacro SplashSetText "Bad fingerprint"
			MessageBox MB_ICONSTOP|MB_TOPMOST "WARNING: Server fingerprint doesn't match. Someone may be attempting to hijack your connection. Please re-download ${FULLNAME} from ${WEBSITE}. If the problem persist, please contact support."
			Call UnloadGUI
		${OrIf} $R0 == "invalid host"
			!insertmacro SplashSetText "Invalid host"
			MessageBox MB_ICONSTOP|MB_TOPMOST "Invalid host. Please check your internet connection."
			Call UnloadGUI
		${EndIf}
	${EndIf}
FunctionEnd

Function CheckForBadclient
	${DebugHeader} "CheckForBadClient"
;	StrCmp $DEBUGON 1 "" +2
;		MessageBox MB_OK|MB_TOPMOST `Running CheckForBadclient. LaunchedExecutable = $LaunchedExecutable`
;	StrCmp $DEBUGON 2 "" +3
;		${time::GetLocalTime} $R0
;		FileWrite $4 "$R0 CheckForBadclient: LaunchedExecutable = $LaunchedExecutable$\r$\n"
;	${If} ${IsProcessRunning} $PROGRAMEXECUTABLE ;See if client application is running.
;		${If} $LaunchedExecutable = 0 ;And we haven't ever called it to run...
;			newadvsplash::stop
;			MessageBox MB_OK|MB_TOPMOST `Do not start $PROGRAMEXECUTABLE while ${NAME} is loading. $PROGRAMEXECUTABLE will now terminate and ${NAME} will continue to load.`
;			KillProcDLL::KillProc "$PROGRAMEXECUTABLE" 
;			Sleep 2000
;		${EndIf}
;	${EndIf}	
FunctionEnd

Function CheckTheTime
  ${time::GetLocalTime} $R1 ;Get the current time
  ${time::MathTime} "second($R1) - second($LAUNCHTIME) =" $CIRCUITTIMER ;Current time in seconds - launch time = circuittimer (time passed in seconds)
FunctionEnd

;Here is a list of what it means when torcircuitstatus.exe returns a value. It naturally uses the errorlevel as the return medium.
Function ProcessFlags

  ${DebugHeader} "ProcessFlags"

${IF} $NUMCIRCUITS != ""
  ${If} $NUMCIRCUITS < 0

    StrCpy $FLAGCODE "Tor: System Error ($NUMCIRCUITS)"
    ${DebugHeader} "Error Flag: $FLAGCODE"

  ${ElseIf} $NUMCIRCUITS >= 0 ;If the response code is between 0 and 249...

    ${If} $NUMCIRCUITS < 250
      ${If} $NUMCIRCUITS >= 1 ;And if there is indeed a circuit, lets say there is success.
        StrCpy $FLAGCODE "Tor Connections: CONNECTED! $NUMCIRCUITS Circuits Established"
		!insertmacro SplashSetText "CONNECTED"
        ${DebugHeader} "Error Flag: $FLAGCODE SUCCESS"
      ${ElseIf} $NUMCIRCUITS == 0
        StrCpy $FLAGCODE "Tor Connections: None"
        ${DebugHeader} "Error Flag: $FLAGCODE"
      ${EndIf}
    ${EndIf}

  ${EndIf}

  ${Switch} $NUMCIRCUITS
    ${Case} 250
      StrCpy $FLAGCODE "Tor: OK ($NUMCIRCUITS)"
      ${Break}
    ${Case} 251
      StrCpy $FLAGCODE "Tor: UNNECESSARY OPERATION ($NUMCIRCUITS)"
      ${Break}
    ${Case} 451
      StrCpy $FLAGCODE "Tor: RESOURCE EXHAUSTED ($NUMCIRCUITS)"
      ${Break}
    ${Case} 500
      StrCpy $FLAGCODE "Tor: PROTOCOL SYNTAX ERROR ($NUMCIRCUITS)"
      ${Break}
    ${Case} 510
      StrCpy $FLAGCODE "Tor: UNRECOGNIZED COMMAND ($NUMCIRCUITS)"
      ${Break}
    ${Case} 511
      StrCpy $FLAGCODE "Tor: UNIMPLEMENTED COMMAND ($NUMCIRCUITS)"
      ${Break}
    ${Case} 512
      StrCpy $FLAGCODE "Tor: COMMAND ARGUMENT SYNTAX ERROR ($NUMCIRCUITS)"
      ${Break}
    ${Case} 513
      StrCpy $FLAGCODE "Tor: UNRECOGNIZED COMMAND ARGUMENT ($NUMCIRCUITS)"
      ${Break}
    ${Case} 514
      StrCpy $FLAGCODE "Tor: AUTHENTICATION REQUIRED ($NUMCIRCUITS)"
      ${Break}
    ${Case} 515
      StrCpy $FLAGCODE "Tor: BAD AUTHENTICATION ($NUMCIRCUITS)"
      ${Break}
    ${Case} 550
      StrCpy $FLAGCODE "Tor: UNSPECIFIED ERROR ($NUMCIRCUITS)"
      ${Break}
    ${Case} 551
      StrCpy $FLAGCODE "Tor: INTERNAL ERROR ($NUMCIRCUITS)"
      ${Break}
    ${Case} 552
      StrCpy $FLAGCODE "Tor: UNRECOGNIZED ENTITY ($NUMCIRCUITS)"
      ${Break}
    ${Case} 553
      StrCpy $FLAGCODE "Tor: INVALID CONFIG VALUE ($NUMCIRCUITS)"
      ${Break}
    ${Case} 554
      StrCpy $FLAGCODE "Tor: INVALID DESCRIPTOR ($NUMCIRCUITS)"
      ${Break}
    ${Case} 555
      StrCpy $FLAGCODE "Tor: UNMANAGED ENTITY ($NUMCIRCUITS)"
      ${Break}
    ${Case} 650
      StrCpy $FLAGCODE "Tor: ASYNC EVENT NOTIFICATION ($NUMCIRCUITS)"
      ${Break}
    ${Case} 1501
      StrCpy $FLAGCODE "TorCircuitStatus: INVALID CONTROL PORT ($NUMCIRCUITS)"
      ${Break}
    ${Case} 1502
      StrCpy $FLAGCODE "TorCircuitStatus: UNABLE TO CONNECT ($NUMCIRCUITS)"
      ${Break}
    ${Case} 1503
      StrCpy $FLAGCODE "TorCircuitStatus: UNABLE TO COMMUNICATE ($NUMCIRCUITS)"
      ${Break}
    ${Case} 1504
      StrCpy $FLAGCODE "TorCircuitStatus: RESPONSE TIMED OUT ($NUMCIRCUITS)"
      ${Break}
    ${Case} 1505
      StrCpy $FLAGCODE "TorCircuitStatus: RESPONSE UNKNOWN ($NUMCIRCUITS)"
      ${Break}
  ${EndSwitch}

${EndIf}

  ${DebugHeader} "Error Flag: $FLAGCODE"

FunctionEnd

Function KillConnectionClientProcess
	${DebugHeader} "KillConnectionClientProcess"
	${If} $SUBMISSIVEMODE != "true" ;If we aren't in submissive mode, kill the client.
		${Do}  ;We are going to create a loop to make sure we kill the client process before exiting.
			${DebugHeader} "Now running the killconnection loop"
			${If} $CONNECTIONMETHOD = 0 ;This is to gracefully shutdown Tor
				${DebugHeader} "KillConnectionClientProcess - Sending Shutdown Signal to $CONNECTIONCLIENT"
				;Star tor, use the torrc we specified, and write the console output to tor.log
				ExecDos::exec /NOUNLOAD `"$EXEDIR\Data\Browser\profile\extensions\${FTC_EXT}\signal.exe" SHUTDOWN $CONTROLPORT` "" ""
			${ElseIf} $CONNECTIONMETHOD > 0
				${DebugHeader} "KillConnectionClientProcess - Sending Kill Signal to $CONNECTIONCLIENT"
				KillProcDLL::KillProc "$CONNECTIONCLIENT"  ;Kill the XeroBank client process (plink)
			${EndIf}
			${Unless} ${IsProcessRunning} $CONNECTIONCLIENT ;If client application (tor/xerobankplus) isn't running, then leave the loop.
				${ExitDo}
			${EndIf}
		${Loop}
	${EndIf}
	Sleep 50 ;a little sleep is needed at the end. If you try to execute too many of these at once, you get a memory error after the program closes.
	ExecDos::exec `"$TORDIRECTORY\tor_resolve.exe"` "" "";Run execdos (any program will do) without NOUNLOAD so that ExecDos.dll isn't left behind
	Sleep 50 ;a little sleep is needed at the end. If you try to execute too many of these at once, you get a memory error after the program closes.
	Call DelDataDir
	Sleep 50 ;a little sleep is needed at the end. If you try to execute too many of these at once, you get a memory error after the program closes.
	RMDir /r $TEMPDIR ;Remove temp dir, this typically doesn't work for some reason, probably because it is $PLUGINSDIR
	Sleep 50
FunctionEnd

Function Throbber ;Throbber
	${DebugHeader} "Throbber"
	${If} $CONNECTIONMETHOD = 0 ;If we are running Tor and not a XeroBank service, launch the Throbber.
		Call ProcessFlags
		StrCpy $CYCLEPOS 0 ;Reset Cycle Position
		${Do}  ;Count to 100
			IntOp $CYCLEPOS $CYCLEPOS + 5 ;Add one to the counter
			${If} $ELLIPSES == ""
				!insertmacro SplashSetText "Connecting to Tor."
				StrCpy $ELLIPSES "."
			${ElseIf} $ELLIPSES == "."
				!insertmacro SplashSetText "Connecting to Tor.."
				StrCpy $ELLIPSES ".."
			${ElseIf} $ELLIPSES == ".."
				!insertmacro SplashSetText "Connecting to Tor..."
				StrCpy $ELLIPSES "..."
			${ElseIf} $ELLIPSES == "..."
				!insertmacro SplashSetText "Connecting to Tor...."
				StrCpy $ELLIPSES "...."
			${ElseIf} $ELLIPSES == "...."
				!insertmacro SplashSetText "Connecting to Tor"
				StrCpy $ELLIPSES ""
			${EndIf}
			Sleep 150
			${If} $CYCLEPOS >= 100
				${ExitDo}
			${EndIf}
		${Loop}
	${EndIf}
FunctionEnd

Function CleanUpProfilePrefs ;Copy the pref.js file back to in order to store the user settings.
	${DebugHeader} "CleanUpProfilePrefs"
	;${If} $PREFSLOADED = 1 ;If we have switched the pref files, switch them back and unload.
	;	${DebugHeader} "CleanUpProfilePrefs: Backing up Preferences..."
	;	${If} $CONNECTIONMETHOD = 0 ;If we are running Tor, save peferences to TOR_prefs
	;		Delete "$PROFILEDIRECTORY\TOR_prefs.js" ;delete any file that already exists
	;		Sleep 50
	;		CopyFiles /SILENT "$PROFILEDIRECTORY\prefs.js" "$PROFILEDIRECTORY\TOR_prefs.js" ;now backup the pref file
	;	${ElseIf} $CONNECTIONMETHOD = 1 ;If we are running any XeroBank services, save preferences to SSH_prefs
	;		${DebugHeader} "CleanUpProfilePrefs: Saving to SSH_prefs.js"
	;		Delete "$PROFILEDIRECTORY\SSH_prefs.js"
	;		Sleep 50
	;		CopyFiles /SILENT "$PROFILEDIRECTORY\prefs.js" "$PROFILEDIRECTORY\SSH_prefs.js"
	;	${ElseIf} $CONNECTIONMETHOD = 2 ;If we are running any other XeroBank services, save preferences to VPN_prefs
	;		${DebugHeader} "CleanUpProfilePrefs: Saving to VPN_prefs.js"
	;		Delete "$PROFILEDIRECTORY\VPN_prefs.js"
	;		Sleep 50
	;		CopyFiles /SILENT "$PROFILEDIRECTORY\prefs.js" "$PROFILEDIRECTORY\VPN_prefs.js"		
	;	${EndIf}
	;	Sleep 500 ; Give the files time to copy
	;	Delete "$PROFILEDIRECTORY\prefs.js" ;Don't leave a profile just lying around. It could accidently overwrite a legit preference file.
		Delete "$PROFILEDIRECTORY\user.js"  ;Don't leave the hardcode settings lying around. We'll call these out each time.
	;	${ElseIf} $PREFSLOADED = 0
	;	${DebugHeader} "CleanUpProfilePrefs: prefs.js was not loaded, so nothing was copied or deleted"
	;${EndIf}
	;${DebugHeader} "CleanUpProfilePrefs - Complete"
	
	;Call ReplaceRegExtensions
	;${DebugHeader} "Replacing Extension Data, if changed."
FunctionEnd

;Function CheckAuth
;	IfFileExists "$TEMPDIR\auth.chk" +3 "" ;Wait till the auth file exists
;		Sleep 50
;		Call CheckAuth
;	FileOpen $8 "$TEMPDIR\auth.chk" r   ;Open the auth.chk
;	FileRead $8 $0 1					;Read the first character
;	FileClose $8						;Close the file
;	StrCmp $0 "" "" +3 ;If there was nothing read restart the function.
;		Sleep 200
;		Call CheckAuth
;	StrCpy $AUTHRETURN $0
;	${DebugHeader} "     Authorization Value = $AUTHRETURN"
;FunctionEnd

Function DelDataDir
	${If} $DELETEDIRDATA == true
		RMDir /r $TORDIRECTORY\data
	${EndIf}
FunctionEnd

Function CONNECTIONHANDLER
	${If} $SUBMISSIVEMODE != true ;If we are in submissive mode, don't worry about this.
		${Unless} ${IsProcessRunning} $CONNECTIONCLIENT ;If tor isn't running...			
			${If} $DEBUGON == 2
				${time::GetLocalTime} $R7
				StrCpy $PROCEDURE "${NAME} | $CONNECTIONCLIENT process has been found to not be running."
				${time::GetLocalTime} $R7
				FileWrite $DEBUGLOG "$R7 $PROCEDURE$\r$\n"
				ClearErrors
				IntOp $CLIENTRESTARTCOUNTER $CLIENTRESTARTCOUNTER + 1
			${EndIf}
			${If} $DEBUGON == 1
				MessageBox MB_OK|MB_TOPMOST "$CONNECTIONCLIENT process has terminated. Restarting $CONNECTIONCLIENT"
			${EndIf}
		${EndIf}
	${Else}
		StrCpy $R0 1 ;OVERRIDING CONNECTION CHECK!
		StrCpy $GOTCONNECTION 1 ;If we are in submissive mode, tell everyone we have a connection.
	${EndIf}
FunctionEnd

Function GetCredentials
  ${If} $HTTPProxyAddress != "" 									;If HTTPProxyAddress isn't blank...
    StrCpy $PROXYSTRING1 "HttpProxy $HTTPProxyAddress:$HTTPProxyPort" 	;Then form the ProxyString for Tor
    StrCpy $InetProxy "/PROXY $HTTPProxyAddress:$HTTPProxyPort"		;Set the InetLoad Proxy Info
    ${If} $HTTPProxyAuth != No  								;If The Authorization doesn't say no
      StrCpy $AUTHSTRING1 $HTTPProxyAuth						;Then copy HTTProxyAuth into the authtring
      ${If} $HTTPPROXYAUTH == Ask							  ;If we have read "Ask" from the ini...
        auth::Ask /TITLE "Network Proxy Authentication"		;Pop open an authorization dialog box
        Pop $0 												; OK or Error string	
        ${If} $0 == OK 									;If OK was pressed...
          Pop $0 											; Login field string
          Pop $1 											; Password field string
          StrCpy $AUTHSTRING1 `HttpProxyAuthenticator $0:$1` ;Form the proxy authentication string for use on the client. ex: httpsproxyauthenticator username:password
          StrCpy $InetAuthUser $0
          StrCpy $InetAuthPassword $1
        ${ElseIf} $0 != "OK"								;If the user didn't press OK
          MessageBox MB_OK|MB_TOPMOST "Your configuration requested to ask for a password for a HTTP proxy connection, but you have chosen not to supply one. ${NAME} will try to connect without these credentials."
        ${EndIf}
      ${EndIf}
    ${ElseIf} $HTTPProxyAuth == No
      StrCpy $AUTHSTRING1 ""								;If auth isn't required, write nothing.
    ${EndIf}
  ${EndIf}
  
    ;https proxy data...
  
  ${If} $HTTPSProxyAddress != ""
    StrCpy $PROXYSTRING2 "HttpsProxy $HTTPSProxyAddress:$HTTPSProxyPort"
    StrCpy $InetProxy "/PROXY $HTTPProxyAddress:$HTTPProxyPort"		;Set the InetLoad Proxy Info
    ${If} $HTTPSProxyAuth != No
      StrCpy $AUTHSTRING2 $HTTPSProxyAuth
      ${If} $HTTPSPROXYAUTH == Ask
        auth::Ask /TITLE "Network Proxy Authentication"
        Pop $0 ; OK or Error string
        ${If} $0 == OK
          Pop $0 ; Login field string
          Pop $1 ; Password field string
          StrCpy $AUTHSTRING2 `HttpsProxyAuthenticator $0:$1`
          StrCpy $InetAuthUser $0
          StrCpy $InetAuthPassword $1
        ${ElseIf} $0 != OK
          MessageBox MB_OK|MB_TOPMOST "Your configuration requested to ask for a password for a HTTPS proxy connection, but you have chosen not to supply one. ${NAME} will try to connect without these credentials."
        ${EndIf}
      ${EndIf}				
    ${ElseIf} $HTTPSProxyAuth == No
      StrCpy $AUTHSTRING2 ""
    ${EndIf}
  ${EndIf}
  
  ;If we have no HTTPS proxy info, but we do have HTTP info, then just copy it as the HTTPS data.
  ${If} $PROXYSTRING2 == "" ;If we have no HTTPS settings...
    ${If} $PROXYSTRING1 != "" ;But we do have HTTP settings...
      StrCpy $PROXYSTRING2 "HttpsProxy $HTTPProxyAddress:$HTTPProxyPort" 	; copy whatever we have from http to it.
      StrCpy $AUTHSTRING2 $AUTHSTRING1 									; copy whatever the http settings were to https settings.
    ${EndIf}
  ${EndIf}
FunctionEnd

!macro Download URL FILE
  ${If} $INETPROXY != ""
    ${If} $AUTHSTRING2 != "" ;Are we using HTTPS proxy auth settings?
    ${OrIf} $AUTHSTRING1 != "" ;Are we using HTTP proxy auth settings?
      inetc::get $INETPROXY /USER $InetAuthUser /PASSWORD $InetAuthPassword "${URL}" "${FILE}" /END
    ${Else} ;No auth
      inetc::get $INETPROXY "${URL}" "${FILE}" /END
    ${EndIf}
  ${Else}
    inetc::get /NOPROXY "${URL}" "${FILE}" /END
  ${EndIf}
  Pop $DOWNLOADRESULT
!macroend

Function RemoveEvil

	Call RemoveYahoo
	Call RemoveRegExtensions
	Call RemoveFlashCache
	!insertmacro SplashSetText "Ready to launch"
	
FunctionEnd

Function RemoveYahoo
	!insertmacro SplashSetText "Checking for tracking data..."
	;Get Rid of the Yahoo Flash Object
	${Locate} "$APPDATA\Macromedia\Flash Player\#SharedObjects" "/M=loginCache.sol" CallBackYFLASH
	;Get Rid of the Yahoo Cookie
	${Locate} "$PROFILE\UserData" "/M=YL[1].xml" CallBackYCOOKIE
	;Remove if user approves
	${If} $YAHOOFLASH != "" ;If we got some data for Yahoo Flash cookie
	${OrIf} $YAHOOCOOKIE != "" ;Or if we got some data for the yahoo data cookie
			!insertmacro SplashSetText "Removing tracking data..."
			Delete $YAHOOFLASH
			Delete $YAHOOCOOKIE
			MessageBox MB_OK "Yahoo tracking data has been removed."
	${EndIf}

FunctionEnd

Function CallBackYFLASH

	StrCpy $YAHOOFLASH $R9
	Push StopLocate

FunctionEnd

Function CallBackYCOOKIE

	StrCpy $YAHOOCOOKIE $R9
	Push StopLocate

FunctionEnd

Function RemoveFlashCache

	StrCpy $R0 ""

	${If} $REMOVEFLASH == "never"

		Return

	${ElseIf} $REMOVEFLASH == "always"

		StrCpy $R0 "delete"

	${EndIf}

	!insertmacro SplashSetText "Looking for Flash cookies..."
	${Locate} "$APPDATA\Macromedia\Flash Player" "/M=*.sol" RemoveFlashCacheCallback

	WriteINIStr "$INIPATH\XeroBank.ini" "${NAME}" RemoveFlash $REMOVEFLASH

FunctionEnd

Function RemoveFlashCacheCallback

	${If} $R0 == ""

		messagebox::show MB_ICONEXCLAMATION|MB_TOPMOST "$(^SetupCaption)" "0,103" "Flash cookies were found on your computer. Cookies threaten your privacy by allowing$\rwebsites to track you. Would you like to ${FULLNAME} remove them?" Yes Always No Never

		Pop $R0

		${If} $R0 == "2"

			StrCpy $REMOVEFLASH "always"
			StrCpy $R0 "delete"

		${ElseIf} $R0 == "3"

			Push "StopLocate"
			Return

		${ElseIf} $R0 == "4"

			StrCpy $REMOVEFLASH "never"
			Push "StopLocate"
			Return

		${EndIf}

	${EndIf}

	Delete $R9

	Push ""
	!insertmacro SplashSetText "Removing Flash cookies..."

FunctionEnd

Function RemoveRegExtensions
	!insertmacro SplashSetText "Looking for hidden extensions..."
	${registry::KeyExists} "${EXTKEY}" $KEYFOUND
	${If} $KEYFOUND == 0
		MessageBox MB_YESNO|MB_ICONEXCLAMATION "Potentially compromising Mozilla extensions were found installed the registry, would you like to disable them?" IDYES "" IDNO End
			${registry::MoveKey} "${EXTKEY}" "HKEY_CURRENT_USER\Software\XeroBank\Backup" $R0
			!insertmacro SplashSetText "Removing hidden extensions..."
			${If} $R0 == 0
				StrCpy $KEYSWITCHED 1
				MessageBox MB_OK "Mozilla extensions were successfully backed up, and will be restored when you close ${Fullname}."
			${ElseIf} $R0 == -1
				MessageBox MB_OK|MB_ICONEXCLAMATION "${Fullname} was unable to remove the extensions. Your account may not have privileges to change the registry."
			${EndIf}
	${EndIf}
  End:
FunctionEnd

Function ReplaceRegExtensions
	${If} $KEYSWITCHED == 1
		${registry::MoveKey} "HKEY_CURRENT_USER\Software\XeroBank\Backup" "${EXTKEY}" $R0
	${EndIf}
FunctionEnd
