;Copyright (C) 2008 Xero Networks AG
;All rights reserved by Xero Networks AG
;This software is licensed under the latest version of the Torrify Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.

!ifndef ___EXTENSIONS_NSH___
!define ___EXTENSIONS_NSH___

!include XML.nsh

Function SetExtensionState

	Push $0

	${xml::LoadFile} "$PROFILEDIRECTORY\extensions.rdf" $0
	${xml::RootElement} $1 $0
	${xml::XPathNode} "/RDF:RDF/RDF:Description[@NS1:name='$R0']" $0
	${If} $0 == "0"
		${xml::SetAttribute} "NS1:userDisabled" $R1 $0
		${If} $0 == "0"
			${xml::SaveFile} "$PROFILEDIRECTORY\extensions.rdf" $0
		${EndIf}
	${EndIf}
	${xml::Unload}

	Delete "$PROFILEDIRECTORY\extensions.cache"
	Delete "$PROFILEDIRECTORY\extensions.ini"

	Pop $0

FunctionEnd

Function EnableExtension

	Exch $R0
	Push $R1

	${DebugHeader} "EnableExtension: $R0"

	StrCpy $R1 "false"
	Call SetExtensionState

	Pop $R1
	Pop $R0

FunctionEnd

Function DisableExtension

	Exch $R0
	Push $R1

	${DebugHeader} "DisableExtension: $R0"

	StrCpy $R1 "true"
	Call SetExtensionState

	Pop $R1
	Pop $R0

FunctionEnd

!macro SetExtensionState STATE EXTENSION

	Push "${EXTENSION}"

	!if ${STATE} == enable

		Call EnableExtension

	!else

		Call DisableExtension

	!endif

!macroend

!define EnableExtension `!insertmacro SetExtensionState enable`
!define DisableExtension `!insertmacro SetExtensionState disable`

!endif # ___EXTENSIONS_NSH___
