;Copyright (C) 2008 Xero Networks AG
;All rights reserved by Xero Networks AG
;This software is licensed under the latest version of the Torrify Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.
;
;

;LogicLib macro that checks if a directory is writable.
;
;${If} ${DirectoryWritable} "$PROGRAMFILES"
;  MessageBox MB_OK "You're probably admin...."
;${EndIf}

!macro _DirectoryWritable _a _b _t _f
  !insertmacro _LOGICLIB_TEMP
  ClearErrors
  FileOpen $_LOGICLIB_TEMP `${_b}\test.dat` 'w'
  FileClose $_LOGICLIB_TEMP
  Delete `${_b}\test.dat`
  IfErrors `${_f}` `${_t}`
!macroend
!define DirectoryWritable `"" DirectoryWritable`

;LogicLib macro that uses FindProc to find a running process.
;
;${If} ${IsProcessRunning} "notepad.exe"
;  MessageBox MB_OK "notepad is running!"
;${EndIf}

!macro _IsProcessRunning _a _b _t _f
  FindProcDLL::FindProc "${_b}"
  !insertmacro _== $R0 1 `${_t}` `${_f}`
!macroend
!define IsProcessRunning `"" IsProcessRunning`

;LogicLib macro that uses iphlpapi.dll to find out if a TCP port is open
;
;${If} ${TCPPortOpen} 8080
;  MessageBox MB_OK "port 8080 is open"
;${EndIf}

!macro _TCPPortOpen _a _b _t _f
  !insertmacro _LOGICLIB_TEMP
  Push `${_b}`
  Call TCPPortOpen
  Pop $_LOGICLIB_TEMP
  !insertmacro _== $_LOGICLIB_TEMP "connected" `${_t}` `${_f}`
!macroend
!define TCPPortOpen `"" TCPPortOpen`

Function TCPPortOpen

	Exch $R0 # port to check
	Push $0
	Push $1
	Push $2

	System::Call 'iphlpapi::GetTcpTable(*i.r0, *i .r1, i 1) i .r2'
	${If} $2 != 122 # ERROR_INSUFFICIENT_BUFFER
		StrCpy $R0 ""
		Pop $2
		Pop $1
		Pop $0
		Exch $R0
		Return
	${EndIf}

	System::Alloc $1
	Pop $0

	System::Call 'iphlpapi::GetTcpTable(ir0, *i r1, i 1) i .r2'
	${If} $2 != 0 # NO_ERROR
		System::Free $0
		StrCpy $R0 ""
		Pop $2
		Pop $1
		Pop $0
		Exch $R0
		Return
	${EndIf}

	Push $3
	Push $4
	Push $5

	System::Call *$0(i.r2)
	IntOp $2 $2 - 1
	${For} $3 0 $2
		IntOp $4 $0 + 4  # skip dwNumEntries
		IntOp $5 $3 * 20 # sizeof(MIB_TCPROW)
		IntOp $4 $4 + $5 # skip to entry
		System::Call *$4(i,i,i.r4,i,i)
		System::Call ws2_32::ntohs(ir4)i.r4

		${If} $4 = $R0
			StrCpy $R0 "connected"
			${Break}
		${EndIf}
	${Next}

	${If} $R0 != "connected"
		StrCpy $R0 ""
	${EndIf}

	System::Free $0

	Pop $5
	Pop $4
	Pop $3
	Pop $2
	Pop $1
	Pop $0
	Exch $R0

FunctionEnd

##################################################
# Java proxy handler
##################################################

!define JAVA_PROPERTIES $APPDATA\Sun\Java\Deployment\deployment.properties

Function SetJavaProxy
	${DebugHeader} "SetJavaProxy"
	!insertmacro SplashSetText "Setting up java..."
	${If} ${FileExists} ${JAVA_PROPERTIES}.xerobank
		${DebugHeader} "SetJavaProxy: xerobank java config backup already found. Reverting to backup, then continuing."
		Delete ${JAVA_PROPERTIES}
		Rename ${JAVA_PROPERTIES}.xerobank ${JAVA_PROPERTIES}
	${EndIf}

	Rename ${JAVA_PROPERTIES} ${JAVA_PROPERTIES}.xerobank

	${LineFind} ${JAVA_PROPERTIES}.xerobank ${JAVA_PROPERTIES} 1:-1 SetJavaProxyCallback
	
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.system.tray.icon=     false $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.browser.vm.iexplorer= false $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.proxy.socks.host=     localhost $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.proxy.type=           1 $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.proxy.same=           true $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.browser.vm.mozilla=   false $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.capture.mime.types=   true $0
	${ConfigWrite} ${JAVA_PROPERTIES} deployment.proxy.socks.port=     $SOCKSPORT $0

FunctionEnd

Function SetJavaProxyCallback

	StrLen $R0 deployment.version
	StrCpy $R0 $R9 $R0
	StrLen $R1 deployment.javapi
	StrCpy $R1 $R9 $R1

	${If} $R0 == deployment.version
	${OrIf} $R1 == deployment.javapi
		Push "WriteLine"
	${Else}
		Push "SkipWrite"
	${EndIf}

FunctionEnd

Function RestoreJavaSettings
	${DebugHeader} "RestoreJavaSettings"
	${Unless} ${FileExists} ${JAVA_PROPERTIES}.xerobank
		${DebugHeader} "  Can't find Java deployment properties backup file."
		Return
	${EndIf}

	Delete ${JAVA_PROPERTIES}
	Rename ${JAVA_PROPERTIES}.xerobank ${JAVA_PROPERTIES}

FunctionEnd

##################################################
# PuTTY settings file
##################################################

Function CreatePuTTYSettings

	File /oname=$EXEDIR\App\.putty\sessions XeroBank ;Unload the session file to the session directory
	${If} $HTTPProxyAddress == ""
	${AndIf} $HTTPSProxyAddress == ""
		${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyMethod=   0	$R0
		;No proxy
	${Else}
		${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyMethod=   3	$R0
		;HTTP Proxy
		${If} $HTTPProxyAddress != "" ;If there is HTTP proxy data
			${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyHost=     $HTTPProxyAddress	$R0
			${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyPort=     $HTTPProxyPort	$R0
		${ElseIf} $HTTPSProxyAddress != "" ;If there is HTTPS proxy data
			${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyHost=     $HTTPSProxyAddress	$R0
			${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyPort=     $HTTPSProxyPort	$R0
		${EndIf}
		${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyUsername= $InetAuthUser	$R0
		${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank ProxyPassword= $InetAuthPassword	$R0
	${EndIf}
	${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank UserName=          $XeroBankUSERNAME $R0
	${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank PublicKeyFile=     $EXEDIR\Data\XeroBank\XeroBank.key $R0
	${ConfigWrite} $EXEDIR\App\.putty\sessions\XeroBank PortForwardings=   L8080:httpproxy.xerobank.com:8080,L$SOCKSPORT:socksproxy.xerobank.com:$SOCKSPORT,	$R0

FunctionEnd

Function StopPluginsLoading
	${DebugHeader} "StopPluginsLoading"
	Delete "$PROFILEDIRECTORY\mimeTypes.rdf"
	File /oname=$PROFILEDIRECTORY\mimeTypes.rdf "..\Library\prefs\mimeTypes.rdf" ;Unload the mimeTypes.rdf file to the profile
FunctionEnd