/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Preferences Toolbar 3.
 *
 * The Initial Developer of the Original Code is
 * Manuel Reimer.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Manuel Reimer <Manuel.Reimer@gmx.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function resetButton() {
    var resetwanted = goPrefBar.msgYesNo(window, goPrefBar.GetString("preferencesPanelOptionsStrings", "questionreset"));
    if (resetwanted) {
        goPrefBar.ImpExp.Import(window, "chrome://prefbar/content/prefbar.rdf", goPrefBar.ImpExp.ImportType_Reset, true);
        goPrefBar.msgAlert(window, goPrefBar.GetString("preferencesPanelOptionsStrings", "resetfinished"));
    }
}

function Startup() {
    // If we run in SeaMonkey 1.x, then init old pref system
    if ("hPrefWindow" in parent) {
        var dataMgr = parent.hPrefWindow.wsm.dataManager;
        var Data = dataMgr.getPageData(panel);
        if (!Data.initialized)
            parent.hPrefWindow.registerOKCallbackFunc(OKCallback);
    }
    // else init new pref system
    else {
        SetFields();
        window.addEventListener("dialogaccept", this.GetFields, true);
    }
}

function SetFields(pageData) {
    var keyeditor = document.getElementById("PrefBarHotkeyEditor");
    var pref = goPrefBar.PrefBranch;
    var hkstr;
    if (pageData && ("hktoggle" in pageData))
        hkstr = pageData.hktoggle;
    else
        hkstr = pref.getCharPref("extensions.prefbar.hktoggle");

    var hkarr = hkstr.split("][");
    if (hkarr.length != 3)
        return true;

    keyeditor.modifiers = hkarr[0];
    keyeditor.key = hkarr[1];
    keyeditor.keycode = hkarr[2];
    keyeditor.update();
    return true;
}

function GetFields(pageData) {
    var keyeditor = document.getElementById("PrefBarHotkeyEditor");
    var pref = goPrefBar.PrefBranch;
    var hkstr = keyeditor.modifiers + "][" +
                keyeditor.key + "][" +
                keyeditor.keycode;
    if (pageData && pageData.initialized)
        pageData.hktoggle = hkstr;
    else
        pref.setCharPref("extensions.prefbar.hktoggle", hkstr);
}

// Old OKCallback for old pref system in SM 1.x
function OKCallback() {
    var dataMgr = parent.hPrefWindow.wsm.dataManager;
    var pageData = dataMgr.getPageData("chrome://prefbar/content/preferencesPanelOptions.xul");
    var pref = parent.hPrefWindow.pref;
    pref.setCharPref("extensions.prefbar.hktoggle", pageData.hktoggle);
}
