;Copyright (C) 2007 Steve Topletz
;All rights reserved by Steve Topletz
;This software is licensed under the latest XeroBank Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.
;
;

!define NAME "TapManager"
!define VER "1.0.0.0"
!include FileFunc.nsh
	!insertmacro GetParameters
	!insertmacro GetOptions
!include LogicLib.nsh

;=== Program Details
Name "${NAME}"
OutFile "${NAME}.exe"

;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel admin
SetCompressor /SOLID LZMA

VAR EXECFILE
VAR ACTION
VAR INF
VAR DRIVER

Section "Main"
	Call GetVariables
	Call StartWriter
	Call GhostWriter 
	Call EndWriter
	Quit
SectionEnd

Function GetVariables
	${GetParameters} $1
	${GetOptions} "$1" "/file=" $EXECFILE
	${GetOptions} "$1" "/action=" $ACTION
	${GetOptions} "$1" "/inf=" $INF
	${GetOptions} "$1" "/driver=" $DRIVER
FunctionEnd

Function GhostWriter
	ExecDos::exec `"$EXECFILE" $ACTION "$INF" $DRIVER` $0
FunctionEnd

Function StartWriter
	${If} $ACTION == "install"
		Delete $EXEDIR\removed.now
		Delete $EXEDIR\removing.now
		Delete $EXEDIR\installed.now
		
		FileOpen $9 $EXEDIR\installing.now w
		FileClose $9
	${EndIf}
	${If} $ACTION == "remove"
		Delete $EXEDIR\removed.now
		Delete $EXEDIR\installed.now
		Delete $EXEDIR\installing.now
		
		FileOpen $9 $EXEDIR\removing.now w
		FileClose $9
	${EndIf}
FunctionEnd

Function EndWriter
	${If} $ACTION == "install"
		FileOpen $8 $EXEDIR\installed.now w
		FileClose $8
		
		Delete $EXEDIR\removed.now
		Delete $EXEDIR\removing.now
		Delete $EXEDIR\installing.now
	${EndIf}
	${If} $ACTION == "remove"
		FileOpen $8 $EXEDIR\removed.now w
		FileClose $8
		
		Delete $EXEDIR\installing.now
		Delete $EXEDIR\removing.now
		Delete $EXEDIR\installed.now
	${EndIf}
FunctionEnd