;Copyright (C) 2007 XEROBANK
;Portions Copyright 2007 Lukas Landis
;This software is licensed under the latest version of the Torrify Ethical Software License Agreement
;The TESLA License can be viewed at http://www.XeroBank.com/tesla.html
;This source code can not be used to create a commercial alternative to XeroBank services.
;
;

!define NAME "xBVPN"
!define FULL_NAME "xB VPN"
!define APP "OpenVPN"
!define COMPANY "XeroBank"
!define WEBSITE "www.xerobank.com"
!define TAPMANAGER "TapManager.exe"
!define DEFAULTLOGDIR "$TEMP"
!define DEFAULTAPPDIR "App\bin"
!define DEFAULTDRVDIR "App\driver"
!define DEFAULTCONFIGDIR "Data\config"
!define DEFAULTEXE "openvpn-gui.exe"
!define TAP32INSTALLEXE "tap32install.exe"
!define TAP64INSTALLEXE "tap64install.exe"					; as per OVPN 2.1RC7 use the same drivers
!define X32DRIVERFILE "x86\OemWin2k.inf"					; as per OVPN 2.1RC7 use the same drivers
!define X32DRIVER "tap0901"									; as per OVPN 2.1RC7 use the same drivers
!define X32GUID "{4d36e972-e325-11ce-bfc1-08002be10318}"	; as per OVPN 2.1RC7 use the same drivers
!define X64DRIVERFILE "x64\OemWin2k.inf"						
!define X64DRIVER "tap0901"
!define X64GUID "{4d36e972-e325-11ce-bfc1-08002be10318}"
!define CONFIGFILE "*.ovpn"
!define DEFAULTCONFIG `Best Effort.ovpn`
!define DEFAULTCONFIG2 "XeroBank-Reliable.ovpn"
!define CONFIGSTRING '--connect "$CONFIG"'
;!define CONFIGSTRING "--connect XeroBank-Fast.ovpn"
!define UPDATELOC "https://update.xerobank.com/distro/${NAME}/latest.ver" ;latest version
!define UPDATEMSG "https://update.xerobank.com/distro/${NAME}/latest.msg" ;latest version message
!define BROWSER "xBBrowser.exe"
!define MAIL "xBMail.exe"

;Splash settings
!define SPLASH_BITMAP "xBBrowser.bmp" # can only be bitmap
!define SPLASH_TEXT_FONT "Arial"
!define SPLASH_TEXT_SIZE 8
!define SPLASH_TEXT_WEIGHT 100
!define SPLASH_TEXT_R 255
!define SPLASH_TEXT_G 255
!define SPLASH_TEXT_B 255
!define SPLASH_TEXT_X1 4
!define SPLASH_TEXT_Y1 185
!define SPLASH_TEXT_X2 500
!define SPLASH_TEXT_Y2 200

!define SPLASH_VER_R 255
!define SPLASH_VER_G 255
!define SPLASH_VER_B 255
!define SPLASH_VER_X1 290
!define SPLASH_VER_Y1 115
!define SPLASH_VER_X2 360
!define SPLASH_VER_Y2 135

; Program Details
Name "${NAME}"
OutFile "${NAME}.exe"
Caption "${FULL_NAME}"

; Runtime Switches
CRCCheck On
WindowIcon Off
#SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel user
SetCompressor /SOLID LZMA

; Program Icon
Icon "..\..\xbmisc\Icons\${FULL_NAME}.ico"

!include "x64.nsh"
!include "LogicLib.nsh"
!include "Splash.nsh"
!include "Version.nsh"
!include "FileFunc.nsh"
	!insertmacro GetParameters
	!insertmacro GetOptions

Var PROGRAMDIRECTORY
Var DRIVERDIRECTORY
Var CONFIGDIRECTORY
Var CONFIG
Var LOGDIRECTORY
Var EXECSTRING
Var INFFILE
Var TAPDRIVER
Var TAPEXE
Var DRIVERGUID
VAR USERCONF

VAR STATUS
VAR CHECKEDUPDATE
VAR MESSAGE

!macro _IsProcessRunning _a _b _t _f
  FindProcDLL::FindProc "${_b}"
  !insertmacro _== $R0 1 `${_t}` `${_f}`
!macroend
!define IsProcessRunning `"" IsProcessRunning`

Function .onGUIInit

	# initialize splash screen
	!insertmacro SplashInit "${NAME}.bmp"

	# hide window
	System::Call gdi32::CreateRectRgn(i0,i0,i0,i0)i.r0
	System::Call user32::SetWindowRgn(i$HWNDPARENT,ir0,i0)

FunctionEnd

Function .onGUIEnd

	!insertmacro SplashDestroy

FunctionEnd

Section "Main"
	Call GetVariables
	Call CreateMutex
	Call SetSystemBase
	;Call CheckWritePrivileges 			What for?
	Call SplashScreen
	Call CheckDirectories
	Call CheckConfig
	Call SetExecString
	Call CheckForDriver
	Call DecideInstall
	Call Launch
	Call Cleanup
SectionEnd

Function GetVariables
	${GetParameters} $1
	${GetOptions} "$1" "/conf=" $USERCONF ;pleonasm request
FunctionEnd

Function SplashScreen
	!insertmacro SplashSetText "Loading..."
	Sleep 1000
FunctionEnd

Function CheckPrivileges ;Check to see if the user running this program has privileges to add/remove device drivers.
	!insertmacro SplashSetText "Checking user privileges..."
	UserInfo::GetName ;Get the username (this will NOT work under win9x)
	Pop $8 ;Pop it from the stack
	UserMgr::AddPrivilege $8 SeLoadDriverPrivilege ;Now check to see if the user has privileges to load drivers
	Pop $9 ;Pop it from the stack
	${If} $9 != "OK" ;If the user does not have privileges
		MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST `User account $8 does not have privileges to install/uninstall drivers.`
	${EndIf}
FunctionEnd

;Function CheckWritePrivileges
;	!insertmacro SplashSetText "Checking disk permissions..."
;	ClearErrors
;	${If} ${FileExists} $TEMP
;		;Do nothing
;	${Else}
;		CreateDirectory $TEMP
;	${EndIf}
;	FileOpen $R0 $TEMP\temp.tmp a
;	FileClose $R0
;	${If} ${Errors}
;		MessageBox MB_OK|MB_ICONSTOP|MB_TOPMOST "You Do Not Have Access to Write to $EXEDIR."
;		!insertmacro SplashDestroy
;		Abort
;	${EndIf}
;	Delete $TEMP\temp.tmp
;FunctionEnd

Function CheckForDriver
	!insertmacro SplashSetText "Checking nework driver..."
	InstDrv::InitDriverSetup /NOUNLOAD $DRIVERGUID $TAPDRIVER
	InstDrv::CountDevices
	Pop $0
	${If} $0 == "0" ;If there is no taps driver installed...
		StrCpy $STATUS "NotInstalled"
	${OrIf} $0 == "1" ;If we show a taps driver is installed...
		${IfNot} ${FileExists} "$PROGRAMDIRECTORY\installed.now" ;but we can't find proof it was...
			StrCpy $STATUS "BadInstalled"
		${Else}
			StrCpy $STATUS "Installed"
		${EndIf}
	${EndIf}
	
FunctionEnd

Function DecideInstall
	${If} $STATUS == "NotInstalled"
		Call BeginInstall
	${EndIf}
	${If} $STATUS == "BadInstalled"
		Call UninstallDriver ;Remove the stuck driver
		Call BeginInstall
	${EndIf}
FunctionEnd

Function BeginInstall
	MessageBox MB_YESNO|MB_ICONQUESTION|MB_TOPMOST `Install required virtual network drivers for ${NAME}?` IDYES DoIt IDNO DontDoIt
	DoIt:
		Call InstallDriver
		Goto TooSexy
	DontDoIt:
		;Do Something
	TooSexy:
		;Just incase we want to do something in the future
FunctionEnd

Function SetSystemBase
	System::Call "kernel32::GetCurrentProcess() i .s"		;**
	System::Call "kernel32::IsWow64Process(i s, *i .r0)"	;**Load a check for 64-bit OS
	${If} ${RunningX64} ;If we are running on a 64bit system...
	${OrIf} $0 == "1" ;Check the earlier test for 64-bit incase RunningX64 didn't work out.
		!insertmacro SplashSetText "Loading x64 drivers..."
		StrCpy $INFFILE ${X64DRIVERFILE}
		StrCpy $TAPDRIVER ${X64DRIVER}
		StrCpy $TAPEXE ${TAP64INSTALLEXE}
		StrCpy $DRIVERGUID ${X64GUID}
	${Else}				;If we are running on a 32bit system...
		!insertmacro SplashSetText "Loading x86 drivers..."
		StrCpy $INFFILE ${X32DRIVERFILE}
		StrCpy $TAPDRIVER ${X32DRIVER}
		StrCpy $TAPEXE ${TAP32INSTALLEXE}
		StrCpy $DRIVERGUID ${X32GUID}
	${EndIf}
FunctionEnd

Function InstallDriver
	!insertmacro SplashSetText "Installing VPN driver..."
	ExecShell "open" "$PROGRAMDIRECTORY\${TAPMANAGER}" '/file=$PROGRAMDIRECTORY\$TAPEXE /action=install /inf=$DRIVERDIRECTORY\$INFFILE /driver=$TAPDRIVER'
	Call WaitForTapInstall
	Call CheckForDriver
	${If} $STATUS == "Installed"
		Call RestartIfNotx64
	${EndIf}
	${If} $STATUS == "NotInstalled"
		MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST "The virtual network driver did not install correctly. Please contact support for assistance, or install OpenVPN."
	${EndIf}
	${If} $STATUS == "BadInstalled"
		MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST "The virtual network driver did not install correctly. Please contact support for assistance, or install OpenVPN."
	${EndIf}
FunctionEnd

Function UninstallDriver
	ExecShell "open" "$PROGRAMDIRECTORY\${TAPMANAGER}" '/file=$PROGRAMDIRECTORY\$TAPEXE /action=remove /inf=$DRIVERDIRECTORY\$INFFILE /driver=$TAPDRIVER'
	Call WaitForTapRemove
FunctionEnd

Function CreateMutex
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "${NAME}Mutex") i .r1 ?e' ;Create Mutex
	Pop $R5
	${If} $R5 != "0"
		MessageBox MB_OK|MB_ICONQUESTION|MB_TOPMOST `It appears that ${NAME} is already running.`
		Quit
	${EndIf}
FunctionEnd

Function CheckDirectories
	!insertmacro SplashSetText "Checking directory structure..."
	${If} ${FileExists} "$EXEDIR\${DEFAULTAPPDIR}\${DEFAULTEXE}"
		StrCpy $PROGRAMDIRECTORY "$EXEDIR\${DEFAULTAPPDIR}"
	${Else}
		MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST `$EXEDIR\${DEFAULTAPPDIR}\${DEFAULTEXE} was not found.  Please check your configuration`
		!insertmacro SplashDestroy
		Abort
	${EndIf}
	
	${If} ${FileExists} "$EXEDIR\${DEFAULTDRVDIR}\$INFFILE" 
		StrCpy $DRIVERDIRECTORY "$EXEDIR\${DEFAULTDRVDIR}"
	${Else}
		MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST `$EXEDIR\${DEFAULTDRVDIR}\$INFFILE was not found.  Please check your configuration`
		!insertmacro SplashDestroy
		Abort
	${EndIf}

	StrCpy $CONFIGDIRECTORY "$EXEDIR\${DEFAULTCONFIGDIR}"
	
	${If} ${FileExists} "${DEFAULTLOGDIR}\*.*" 
		StrCpy $LOGDIRECTORY "${DEFAULTLOGDIR}"
	${Else}
		CreateDirectory "${DEFAULTLOGDIR}"
	${EndIf}
	
FunctionEnd

Function CheckConfig
	!insertmacro SplashSetText "Checking configuration..."
	${If} ${FileExists} "$CONFIGDIRECTORY\$USERCONF" 					;If the user has their own config file specified
		StrCpy $CONFIG $USERCONF
		!insertmacro SplashSetText "Custom configuration"
	${Else}
		${If} ${FileExists} "$CONFIGDIRECTORY\${DEFAULTCONFIG}"
			StrCpy $CONFIG "${DEFAULTCONFIG}"
		${ElseIf} ${FileExists} "$CONFIGDIRECTORY\${DEFAULTCONFIG2}"
			StrCpy $CONFIG "${DEFAULTCONFIG2}"
		${Else}
			ClearErrors
			FindFirst $0 $1 "$CONFIGDIRECTORY\${CONFIGFILE}"
			${IfNot} ${Errors}
				StrCpy $CONFIG $1
				FindClose $0
			${EndIf}
		${EndIf}
	${EndIf}
FunctionEnd

Function SetExecString
	StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\${DEFAULTEXE}" --config_dir "$CONFIGDIRECTORY" --ext_string "ovpn" --exe_path "$PROGRAMDIRECTORY\openvpn.exe" --log_dir "$TEMP" --priority_string "NORMAL_PRIORITY_CLASS" --append_string "0"`
	${If} $CONFIG != ""
		StrCpy $EXECSTRING '$EXECSTRING ${CONFIGSTRING}'
	${EndIf}
FunctionEnd

Function Launch
	!insertmacro SplashSetText "Launching VPN client..."
	Sleep 5000
	Exec "$EXECSTRING" ;Launch the client
	Sleep 5000	;Wait a minute
	!insertmacro SplashDestroy
	Call CheckUpdate	;Then check for updates
	${Do} ;When the program is closed, then finish the function.
		Sleep 1000
		${If} ${IsProcessRunning} "${DEFAULTEXE}"
			Call CheckUpdate
		${Else}
			${ExitDo}
		${EndIf}
	${Loop}
FunctionEnd

Function Cleanup
	${If} ${FileExists} "$EXEDIR\${BROWSER}" ;If we are in a directory with xB Browser
	${OrIf} ${FileExists} "$EXEDIR\${MAIL}"  ;or xB Mail
		Return								 ;then go home
	${ElseIf} $EXEDIR != "$PROGRAMFILES\${COMPANY}" ;Otherwise, if this program wasn't executed from the formal installation dir, ask if they want to uninstall
		MessageBox MB_YESNO|MB_ICONQUESTION|MB_TOPMOST "Would you like to uninstall the ${FULL_NAME} network drivers?" IDYES Yes IDNO No
		Yes:
			Call UninstallDriver
			Goto End
		No:
			;Do Something?
		End:
			;Do something.
	${EndIf}
FunctionEnd

Function CheckUpdate
	${If} $CheckedUpdate == "1"
		Return
	${EndIf}
	!insertmacro SplashSetText "Checking for updates..."
	inetc::get "${UPDATELOC}" "$TEMP\${NAME}.latest.ver" ;Get the latest version file.
	inetc::get "${UPDATEMSG}" "$TEMP\${NAME}.latest.msg" ;Get the latest message file.
	FileOpen $7 "$TEMP\${NAME}.latest.ver" r
	FileRead $7 $1 ;Read the first line of $7 into register $1
	FileClose $7 ;Close ver.chk
	Delete "$TEMP\${NAME}.latest.ver"
	${If} $1 != "" ;If $1 isn't blank...
		${If} $1 != "${VER}${SUBVERSION}" ;And if the latest version doesn't equal the current version...
			FileOpen $7 "$TEMP\${NAME}.latest.msg" r ;Open the message 
			${Do}
				FileRead $7 $2 ;Read the first line of $7 into register $2
				${If} $2 == ""
					${ExitDo}
				${EndIf}
				StrCpy $MESSAGE "$MESSAGE$2"
			${Loop}
			FileClose $7 ;Close ver.chk
			Delete "$TEMP\${NAME}.latest.msg" ;if we're done, let's go.
			MessageBox MB_OK|MB_TOPMOST|MB_ICONEXCLAMATION "${FULL_NAME} v$1 is now available. $\n$\n$MESSAGE $\n$\nTo keep your version of ${NAME} secure, please visit$\nhttp://${WEBSITE} to download the latest version." 
		${EndIf}
	${EndIf}
	StrCpy $CheckedUpdate "1"
FunctionEnd

Function WaitForTapInstall ;Add this after install or remove so it waits for ExecShell to exit.
	${Do} ;Wait for tap manager to start
		${If} ${FileExists} "$PROGRAMDIRECTORY\installing.now"
			${ExitDo}
		${EndIf}
	${Loop}
	;*** Now TapManager is running ***
	${Do} 
		${If} ${FileExists} "$PROGRAMDIRECTORY\installed.now"
			${ExitDo}
		${EndIf}
	${Loop} ; Wait for it to end
FunctionEnd

Function WaitForTapRemove ;Add this after install or remove so it waits for ExecShell to exit.
	${Do} ;Wait for tap manager to start
		${If} ${FileExists} "$PROGRAMDIRECTORY\removing.now"
			${ExitDo}
		${EndIf}
	${Loop}
	;*** Now TapManager is running ***
	${Do} 
		${If} ${FileExists} "$PROGRAMDIRECTORY\removed.now"
			${ExitDo}
		${EndIf}
	${Loop} ; Wait for it to end
FunctionEnd

Function RestartIfNotx64 ;because x64/vista seems to handle network stack well...
	System::Call "kernel32::GetCurrentProcess() i .s"		;**
	System::Call "kernel32::IsWow64Process(i s, *i .r0)"	;**Load a check for 64-bit OS
	${If} ${RunningX64} ;If we are running on a 64bit system...
		;Do nothing
	${Else}
		MessageBox MB_YESNO|MB_ICONQUESTION|MB_TOPMOST "VPN Network drivers have been installed. It is strongly suggested that you reboot. Would you like to reboot now?" IDYES GotoReboot IDNO DontReboot
			GotoReboot:
				Reboot
			DontReboot:
				;Do nothing
	${EndIf}
	
FunctionEnd
